#!usr/bin/wish

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#                                                                       #
#  sfia - software for inspection automation v. 1.0.2                   #
#                                                                       #
#  Idea: Jorma Sajaniemi                                                #
#  Toteutus: Vesa Tenhunen                                              #
#  Copyright: Joensuun yliopisto, tietojenksittelytieteen laitos 2001  #
#                                                                       #
#  Tst jakeluversiosta on poistettu lhdekoodin kommentit.            #
#                                                                       #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




proc asetaAlkuasetukset {} {
   global env k m

   set m(dokumentti) ""
   set m(dokversio) ""
   set m(huomautustiedosto) ""
   set m(kayttaja) $env(USER)
   set m(kieli) 0
   set m(merkinkoko) 8
   set m(muuttunut) 0
   set m(rajoitukset) 1
   set m(tekija) ""
   set m(luontipvm) ""
   set m(sfia-copyright) "(c) 2001 Joensuun yliopisto\nTietojenksittelytieteen laitos"
   set m(sfia-idea) "Jorma Sajaniemi"
   set m(sfia-toteutus) "Vesa Tenhunen"
   set m(sfia-versio) 1.0.2

   set k(kielet) {Suomi English}
}

proc asetaIkkunanKoko {} {

   set koord [.tyotila.sivu bbox all]
   set lev [expr [lindex $koord 2] + 25]
   set kor [expr [lindex $koord 3] + 90]

   if {$kor > [winfo screenheight .]} {
      set kor [winfo screenheight .]
   }
   if {$lev > [winfo screenwidth .]} {
      set lev [winfo screenwidth .]
   }

   wm geometry  . [expr $lev]x[expr $kor]
   wm deiconify .
}

proc asetaIkkunanOtsikko {} {
   global m

   if {$m(dokumentti) == ""} {
      wm title . "sfia $m(sfia-versio)"
   } else {
      wm title . "$m(dokumentti) - sfia $m(sfia-versio)"
   }
}


proc asetaTekstit {} {
   global t

   lappend t(arvotjaselitteet) \
            {Arvot ja selitteet} \
            {Values & Legends}
   lappend t(avaa) \
            {Avaa} \
            {Open}
   lappend t(avaatiedosto) \
            {Avaa tiedosto} \
            {Open File}
   lappend t(dokumentti) \
            {Dokumentti} \
            {Document}
   lappend t(eihuomautuksia) \
            {Dokumentissa ei ole yhtn huomautusta.} \
            {There are no comments in the document.}
   lappend t(eiraportoitavaa) \
            {Raporttia ei voi tehd} \
            {Cannot create report}
   lappend t(eivalittu) \
            {Ei valittu} \
            {Not Selected}
   lappend t(huomautuksenpoistaminen) \
            {Poistetaanko huomautus?} \
            {Delete comment?}
   lappend t(huomautuksenpoistaminen2) \
            {Haluatko poistaa koko huomautuksen?} \
            {Do you want to delete the whole comment?}
   lappend t(huomautuslista) \
            {Huomautuslista} \
            {Comment List}
   lappend t(huomautustekstipuuttuu) \
            {Et kirjoittanut huomautuksen teksti.} \
            {You didn't write the comment text.}
   lappend t(huomioitu) \
            {Huomioitu} \
            {Notified}
   lappend t(hylkaajasulje) \
            {Hylk ja sulje} \
            {Cancel & close}
   lappend t(hyvaksyalasulje) \
            {Hyvksy, l sulje} \
            {Approve, don't close}
   lappend t(hyvaksyjasulje) \
            {Hyvksy ja sulje} \
            {Approve & close}
   lappend t(idea) \
            {Idea} \
            {Idea}
   lappend t(joy) \
            {Joensuun yliopisto} \
            {University of Joensuu}
   lappend t(kaikki) \
            {Kaikki} \
            {All}
   lappend t(kaikkihuomautukset) \
            {Kaikki huomautukset} \
            {All Comments}
   lappend t(kasitelty) \
            {Ksitelty} \
            {Finished}
   lappend t(kaikkikasittelemattomiksi) \
            {Merkitse kaikki huomautukset ksittelemttmiksi} \
            {Mark All Comments As Unfinished}
   lappend t(kasittelematta) \
            {Ksittelemtt} \
            {Unfinished}
   lappend t(kasittelyntila) \
            {Ksittelyn tila} \
            {Status}
   lappend t(keskikoko) \
            {Keskikoko} \
            {Normal}
   lappend t(kieli) \
            {Kieli} \
            {Language}
   lappend t(kirjoitusvirhe) \
            {Tallennus ei onnistunut tiedostoon} \
            {Error saving file}
   lappend t(lopeta) \
            {Lopeta} \
            {Exit}
   lappend t(lukuvirhe) \
            {Virhe luettaessa tiedostoa} \
            {Error reading file}
   lappend t(luoraportti) \
            {Luo raportti} \
            {Create Report}
   lappend t(merkinkoko) \
            {Huomautusmerkin koko} \
            {Comment Mark Size}
   lappend t(muokkaa) \
            {Muokkaa} \
            {Edit}
   lappend t(muokkaahuomautusta) \
            {Muokkaa huomautusta} \
            {Edit Comment}
   lappend t(muokkausikkunoidensulkeminen) \
            {Huomautusikkunat tytyy ensin sulkea. Haluatko sulkea ja hyvksy kaikki ikkunat?} \
            {Edit windows must be closed first. Do you want to approve and close all windows?}
   lappend t(nayta) \
            {Nyt} \
            {View}
   lappend t(ohje) \
            {Ohje} \
            {Help}
   lappend t(paivays) \
            {Pivys} \
            {Date}
   lappend t(peruuta) \
            {Peruuta} \
            {Cancel}
   lappend t(pieni)\
            {Pieni} \
            {Small}
   lappend t(pienin) \
            {Pienin} \
            {Smallest}
   lappend t(poista) \
            {Poista} \
            {Delete}
   lappend t(rajoituksetkaytossa) \
            {Rajoitukset kytss} \
            {Restrictions On}
   lappend t(raportti) \
            {Raportti} \
            {Report}
   lappend t(siirry) \
            {Siirry sivulle} \
            {Go to page}
   lappend t(sivu) \
            {Sivu} \
            {Page}
   lappend t(sulje) \
            {Sulje} \
            {Close}
   lappend t(sulje2) \
            {Sulje} \
            {Dismiss}
   lappend t(suljemuokkausikkunat)\
            {Sulje muokkausikkunat} \
            {Close Edit Windows}
   lappend t(suuri) \
            {Suuri} \
            {Large}
   lappend t(suurin) \
            {Suurin} \
            {Largest}
   lappend t(taiaiemmin) \
            {tai aiemmin} \
            {or above}
   lappend t(tallenna) \
            {Tallenna} \
            {Save}
   lappend t(tallentaminen) \
            {Tallennetaanko muutokset tiedostoon} \
            {Save changes to file}
   lappend t(tarkastaja) \
            {Tarkastaja} \
            {Inspector}
   lappend t(tekija) \
            {Tekija} \
            {Author}
   lappend t(tiedosto) \
            {Tiedosto} \
            {File}
   lappend t(tiedostoolemassa) \
            {Tiedosto on olemassa} \
            {File Exists}
   lappend t(tietoja) \
            {Tietoja ohjelmasta} \
            {About sfia}
   lappend t(tkt) \
            {Tietojenksittelytieteen laitos} \
            {Department of Computer Science}
   lappend t(toteutus) \
            {Toteutus} \
            {Implementation}
   lappend t(tulosta) \
            {Tulosta} \
            {Print}
   lappend t(tulostuskomento) \
            {Tulostuskomento} \
            {Print Command}
   lappend t(valitse) \
            {Valitse} \
            {Select}
   lappend t(valitsetarkastajat) \
            {Valitse tarkastajat} \
            {Select Inspectors}
   lappend t(valitsetarkastajat2) \
            {Valitse tarkastajat, joiden huomautukset haluat nkyville.} \
            {Select the inspectors whose comments you want to see.}
   lappend t(virhe) \
            {Virhe} \
            {Error}
   lappend t(virheellinendokumentintieto) \
            {Virhe dokumentin alkutiedoissa.} \
            {Error in document information.}
   lappend t(virheellinenluokanarvo) \
            {Virheellinen luokan arvo.} \
            {Invalid class value.}
   lappend t(virheellinenluokannimi) \
            {Virheellinen luokan nimi.}  \
            {Invalid class name.}
   lappend t(virheellinenluokanselite) \
            {Virheellinen luokan selite.} \
            {Invalid class legend.}
   lappend t(virheellinenpaivays) \
            {Virheellinen pivys.} \
            {Invalid date.}
   lappend t(virheellinensivutiedosto) \
            {Yht tai useampaa mritelty kuvatiedostoa ei lydy.} \
            {One or more of the defined picture files does not exist.}
   lappend t(virheellinentekija) \
            {Puuttuva tekijn nimi.} \
            {Missing author name.}
   lappend t(virheellinentiedosto) \
            {Tiedosto on viallinen.} \
            {File is corrupted.}
   lappend t(virheellinenversio) \
            {Virheellinen tiedoston versionumero.} \
            {Invalid version number of the file.}
   lappend t(virherivilla) \
            {Virhe rivill} \
            {Error at line}
   lappend t(yhteensa) \
            {Yhteens} \
            {Total}
   lappend t(yhteenveto) \
            {Yhteenveto} \
            {Summary}
}

proc lataaKielitiedot {kieli} {
   global k t

   foreach teksti [array names t] {
      set k($teksti) [lindex $t($teksti) $kieli]
   }
}

proc vaihdaKieli {kieli} {
   global k m

   vaihdaKohdistin watch

   lataaKielitiedot $kieli

   .menu.tiedosto configure -text "$k(tiedosto)"
   .menu.tiedosto.t entryconfigure 1 -label "$k(avaa)..."
   .menu.tiedosto.t entryconfigure 2 -label "$k(tallenna)"
   .menu.tiedosto.t entryconfigure 3 -label "$k(sulje)"
   .menu.tiedosto.t entryconfigure 5 -label "$k(luoraportti)"
   .menu.tiedosto.t entryconfigure 7 -label "$k(lopeta)"
   .menu.tiedosto.raportti entryconfigure 0 -label "$k(kaikkihuomautukset)"
   .menu.tiedosto.raportti entryconfigure 1 -label "$k(yhteenveto)"
   .menu.muokkaa configure -text "$k(muokkaa)"
   .menu.muokkaa.m entryconfigure 1 -label "$k(kieli)"
   .menu.muokkaa.m entryconfigure 2 -label "$k(merkinkoko)"
   .menu.muokkaa.koko entryconfigure 0 -label "$k(pienin)"
   .menu.muokkaa.koko entryconfigure 1 -label "$k(pieni)"
   .menu.muokkaa.koko entryconfigure 2 -label "$k(keskikoko)"
   .menu.muokkaa.koko entryconfigure 3 -label "$k(suuri)"
   .menu.muokkaa.koko entryconfigure 4 -label "$k(suurin)"
   .menu.muokkaa.m entryconfigure 4 -label "$k(rajoituksetkaytossa)"
   .menu.muokkaa.m entryconfigure 5 -label "$k(kaikkikasittelemattomiksi)"
   .menu.nayta configure -text "$k(nayta)"
   .menu.nayta.n entryconfigure 1 -label "$k(valitsetarkastajat)..."
   .menu.nayta.n entryconfigure 2 -label "$k(huomautuslista)"
   .menu.nayta.n entryconfigure 3 -label "$k(arvotjaselitteet)"
   .menu.ohje configure -text "$k(ohje)"
   .menu.ohje.o entryconfigure 1 -label "$k(ohje)"
   .menu.ohje.o entryconfigure 2 -label "$k(tietoja)"

   .navi.teksti configure -text "$k(siirry)"

   foreach w [winfo children .] {
      switch [winfo class $w] {
         "Huomautusikkuna" {
            set tila [wm state $w]
            if {$m(dokumentti) != ""} {
               paivitaHuomautusikkuna
            }
            wm title $w "$k(huomautuslista)"
            switch $tila {
               "withdrawn" {wm withdraw $w}
               "iconic" {wm iconify $w}
            }
         }
         "Muokkausikkuna" {
            set tila [wm state $w]
            $w.tiedot.otsikko1    configure -text "$k(tarkastaja):"
            $w.tiedot.otsikko2    configure -text "$k(paivays):"
            $w.tiedot.otsikko3    configure -text "$k(sivu):"
            $w.p.tallennaJaSulje  configure -text "$k(hyvaksyjasulje)"
            $w.p.tallennaAlaSulje configure -text "$k(hyvaksyalasulje)"
            $w.p.hylkaaJaSulje configure -text "$k(hylkaajasulje)"
            if {[winfo exists $w.rn.tila.otsikko]} {
               $w.rn.tila.otsikko    configure -text "$k(kasittelyntila):"
               $w.rn.tila.k0         configure -text "$k(kasitelty)"
               $w.rn.tila.k1         configure -text "$k(huomioitu)"
               $w.rn.tila.k2         configure -text "$k(kasittelematta)"
            }
            wm title $w "$k(muokkaahuomautusta)"
            switch $tila {
               "withdrawn" {wm withdraw $w}
               "iconic" {wm iconify $w}
            }
         }
         "Ohjeikkuna" {
            set tila [wm state $w]
            $w.painike.sulje configure -text "$k(sulje2)"
            wm title $w "$k(ohje)"
            switch $tila {
               "withdrawn" {wm withdraw $w}
               "iconic" {wm iconify $w}
            }
         }
         "Raportti-ikkuna" {
            set tila [wm state $w]
            $w.p.tallenna configure -text "$k(tallenna)"
            $w.p.tulosta configure -text "$k(tulosta)"
            $w.p.sulje configure -text "$k(sulje2)"
            if {[$w.t.teksti get 1.0 1.1] == "K" || [$w.t.teksti get 1.0 1.1] == "A"} {
               luoRaportti kaikki
            } else {
               luoRaportti yhteenveto
            }
            switch $tila {
               "withdrawn" {wm withdraw $w}
               "iconic" {wm iconify $w}
            }
         }
         "Seliteikkuna" {
            set tila [wm state $w]
            $w.sulje configure -text "$k(sulje2)"
            wm title $w "$k(arvotjaselitteet)"
            switch $tila {
               "withdrawn" {wm withdraw $w}
               "iconic" {wm iconify $w}
            }
         }
         "Tarkastajaikkuna" {
            set tila [wm state $w]
            $w.rn.otsikko configure -text "$k(valitsetarkastajat2)"
            $w.rn.0       configure -text "$k(kaikki)"
            $w.rn.1       configure -text "$k(valitse):"
            $w.peru       configure -text "$k(peruuta)"
            wm title $w "$k(valitsetarkastajat)"
            switch $tila {
               "withdrawn" {wm withdraw $w}
               "iconic" {wm iconify $w}
            }
         }
      }
   }
   raise .

   vaihdaKohdistin oletus
}


proc vaihdaKohdistin {tyyppi} {
   if {$tyyppi == "oletus"} {
      set tyyppi ""
   }

   . configure -cursor $tyyppi

   if {$tyyppi == ""} {
      .hIkkuna.teksti configure -cursor arrow
   } else {
      .hIkkuna.teksti configure -cursor $tyyppi
   }

   foreach kohta [winfo children .] {
      $kohta configure -cursor $tyyppi
   }
}

proc vaihdaValikonTila {tila} {
   global m

   foreach x {2 3 5} {
      .menu.tiedosto.t entryconfigure $x -state $tila
   }
   .menu.muokkaa.m entryconfigure 2 -state $tila
   .menu.muokkaa.m entryconfigure 4 -state $tila

   if {!$m(rajoitukset)} {
      .menu.muokkaa.m entryconfigure 5 -state $tila
   }
   .menu.nayta configure -state $tila
}


proc poistaHuomautusmerkki {huomID} {
   global d m

   vaihdaKohdistin watch

   if {[winfo exists ".$huomID"]} {
      destroy ".$huomID"
   }
   .tyotila.sivu delete $huomID
   unset d($huomID-x)
   unset d($huomID-y)
   unset d($huomID-tarkastaja)
   unset d($huomID-pvm)
   unset d($huomID-teksti)
   unset d($huomID-tagit)
   unset d($huomID-tila)
   if {[info exists d(luokitukset)]} {
      foreach luokka $d(luokitukset) {
         if {[info exists d($huomID-$luokka)]} {
            unset d($huomID-$luokka)
         }
      }
   }
   set sivuID [lindex [split $huomID -] 0]
   set kohta [lsearch $d($sivuID-huom) $huomID]
   set d($sivuID-huom) [lreplace $d($sivuID-huom) $kohta $kohta]
   if {[llength $d($sivuID-huom)] == 0} {
      unset d($sivuID-huom)
   }

   paivitaHuomautusikkuna
   raise .
   incr m(muuttunut)

   vaihdaKohdistin oletus
}

proc piirraHuomautusmerkki {x y tagit} {
   global d m

   set huomID [lindex $tagit 1]

   .tyotila.sivu create oval [expr $x - $m(merkinkoko)] [expr $y - $m(merkinkoko)] \
      [expr $x + $m(merkinkoko)] [expr $y + $m(merkinkoko)] \
      -outline {} -fill red1 -stipple gray50 -tags $tagit
   if {$m(kayttaja) != $d($huomID-tarkastaja)} {
      .tyotila.sivu itemconfigure $huomID -fill magenta4
   }
   if {$m(kayttaja) == $m(tekija) || !$m(rajoitukset)} {
      switch $d($huomID-tila) {
         "0" {.tyotila.sivu itemconfigure $huomID -fill green3}
         "1" {.tyotila.sivu itemconfigure $huomID -fill yellow}
         "2" {.tyotila.sivu itemconfigure $huomID -fill red1}
      }
   }
}

proc lisaaHuomautusmerkki {x y} {
   global d m

   incr m(muuttunut)
   set huomnro 0
   set sivuID [lindex $d(sivulista) $d(nykysivu)]

   if {[info exists d($sivuID-huom)]} {
      while {[lsearch $d($sivuID-huom) "$sivuID-$huomnro"] != -1} {
         set huomnro [incr huomnro]
      }
   }

   lappend tagit "merkki"
   lappend tagit "$sivuID-$huomnro"

   set d($sivuID-$huomnro-x) $x
   set d($sivuID-$huomnro-y) $y
   set d($sivuID-$huomnro-tarkastaja) $m(kayttaja)
   set d($sivuID-$huomnro-pvm) [clock format [clock seconds] -format "%d.%m.%Y %H.%M"]
   set d($sivuID-$huomnro-teksti) ""
   set d($sivuID-$huomnro-tagit) $tagit
   set d($sivuID-$huomnro-tila) 2

   lisaaHuomautusListaan $sivuID $huomnro $x $y

   piirraHuomautusmerkki $x $y $tagit

   avaaMuokkausikkuna "$sivuID-$huomnro"
}

proc lisaaHuomautusListaan {sivu hnro x y} {
   global d

   set pyory [expr round([expr $y / 10])]
   set loytyi 0

   if {[info exists d($sivu-huom)]} {
      set i 0
      while {$loytyi == 0 && $i < [llength $d($sivu-huom)]} {
         if {[info exists d([lindex $d($sivu-huom) $i]-y)]} {
            if {$pyory > [expr round([expr $d([lindex $d($sivu-huom) $i]-y) / 10])]} {
               incr i
            } elseif {$pyory == [expr round([expr $d([lindex $d($sivu-huom) $i]-y) / 10])]} {
               while {$i < [llength $d($sivu-huom)] && $loytyi == 0 && \
                $pyory == [expr round([expr $d([lindex $d($sivu-huom) $i]-y) / 10])]} {
                  if {$x > $d([lindex $d($sivu-huom) $i]-x)} {
                     incr i
                  } else {
                     set loytyi 1
                     set d($sivu-huom) [linsert $d($sivu-huom) $i "$sivu-$hnro"]
                  }
               }
            } else {
               set loytyi 1
               set d($sivu-huom) [linsert $d($sivu-huom) $i "$sivu-$hnro"]
            }
         }
      }
   }
   if {$loytyi == 0} {
      lappend d($sivu-huom) "$sivu-$hnro"
   }
}


proc siirry {kohde} {
   global d

   vaihdaKohdistin watch

   switch $kohde {
      "ensisivu" {set kohde 0}
      "edelsivu" {set kohde [expr $d(nykysivu) - 1]}
      "seursivu" {set kohde [expr $d(nykysivu) + 1]}
      "viimsivu" {set kohde [expr $d(sivumaara) - 1]}
   }

   if {$kohde >= 0 && $kohde < $d(sivumaara) && $kohde != $d(nykysivu)} {
      naytaSivu $kohde
   }

   vaihdaKohdistin oletus
}

proc naytaHuomautusmerkit {numero} {
   global d

   set sivuID [lindex $d(sivulista) $numero]

   if {$d(tarkastajat) == $d(valituttarkastajat)} {
      set rajoitus 0
   } else {
      set rajoitus 1
   }

   set nayta 1
   if {[info exists d($sivuID-huom)]} {
      foreach huomautus $d($sivuID-huom) {
         if {$rajoitus == 1} {
            if {[lsearch $d(valituttarkastajat) $d($huomautus-tarkastaja)] != -1} {
               set nayta 1
            } else {
               set nayta 0
            }
         }
         if {$nayta == 1} {
            piirraHuomautusmerkki $d($huomautus-x) $d($huomautus-y) $d($huomautus-tagit)
         }
      }
   }
}

proc naytaSivu {numero} {
   global d m sivukuva

   vaihdaKohdistin watch

   .tyotila.sivu delete all
   if {[info exists sivukuva]} {
       image delete $sivukuva
   }
 
   set sivuID [lindex $d(sivulista) $numero]
   set sivukuva [image create photo -file [file join $d(hakemisto) $d($sivuID-kuva)]]
   .tyotila.sivu create image 0 0 -anchor nw -image $sivukuva
   .tyotila.sivu configure -width [image width $sivukuva]
   .tyotila.sivu configure -height [image height $sivukuva]
   set d(nykysivu) $numero

   .tyotila.sivu configure -scrollregion [.tyotila.sivu bbox all] -xscrollincrement 0.5c -yscrollincrement 0.5c

   .navi.naytto configure -text " [expr $numero + 1] / $d(sivumaara)"
   vaihdaPainikkeidenTila normal
   if {$d(nykysivu) == 0} {
      .navi.eka configure -state disabled
      .navi.ed configure -state disabled
   } elseif {$d(nykysivu) == [expr $d(sivumaara) - 1]} {
      .navi.vika configure -state disabled
      .navi.seur configure -state disabled
   }

   if {[info exists d($sivuID-huom)]} {
      naytaHuomautusmerkit $numero
   }

   siirryHuomautusikkunassa $sivuID

   vaihdaKohdistin oletus
}

proc lopeta {} {
   global k m

   set vastaus "no"

   if {$m(muuttunut) > 0} {
     set vastaus [tk_messageBox -icon question -type yesnocancel -title "$k(lopeta)" -parent . \
                 -message "$k(tallentaminen) \"$m(huomautustiedosto)\"?"]
     if {$vastaus == "yes"} {
         tallennaHuomautustiedosto
      }
   }
   if {$vastaus != "cancel"} {
      destroy .
   }
}

proc vaihdaPainikkeidenTila {tila} {
   foreach kohta {eka ed seur vika siirry} {
      .navi.$kohta configure -state $tila
   }
}

proc korostusKayttoon {huomID kohteet} {
   foreach kohde $kohteet {
      switch $kohde {
         "ikkuna" {
            if {[winfo exists .$huomID]} {
               .$huomID.tiedot configure -background yellow
               foreach x [winfo children .$huomID.tiedot] {
                  $x configure -background yellow
               }
            }
         }
         "lista" {
            .hIkkuna.teksti tag configure $huomID -background yellow
         }
         "merkki" {
            .tyotila.sivu itemconfigure $huomID -outline black -width 3
         }
      }
   }
}

proc korostusPois {huomID kohteet} {
   foreach kohde $kohteet {
      switch $kohde {
         "ikkuna" {
            if {[winfo exists .$huomID]} {
               .$huomID.tiedot configure -background [.$huomID.txtkehys cget -background]
               foreach x [winfo children .$huomID.tiedot] {
                  $x configure -background [.$huomID.txtkehys cget -background]
               }
            }
         }
         "lista" {
            .hIkkuna.teksti tag configure $huomID -background {}
         }
         "merkki" {
            .tyotila.sivu itemconfigure $huomID -outline {}
         }
      }
   }
}

proc tarkistaMuokkausikkunat {} {
   global k

   set loytyi 0

   foreach ikkuna [winfo children .] {
      if {[winfo class $ikkuna] == "Muokkausikkuna"} {
         incr loytyi
         break
      }
   }

   if {$loytyi > 0} {
      set vastaus [tk_messageBox -icon warning -type yesno -title "$k(suljemuokkausikkunat)" -parent . \
                  -message $k(muokkausikkunoidensulkeminen)]
      if {$vastaus == "yes"} {
         foreach ikkuna [winfo children .] {
            if {[winfo class $ikkuna] == "Muokkausikkuna"} {
               miHyvaksy $ikkuna 1
            }
         }
         set loytyi 0
      }
   }

   return $loytyi
}
	      
proc sulje {} {
   global k m

   if {[tarkistaMuokkausikkunat] == 0} {
      set vastaus no
      if {$m(muuttunut) > 0} {
         set vastaus [tk_messageBox -icon question -type yesnocancel -title "$k(sulje)" -parent . \
                     -message "$k(tallentaminen) \"$m(huomautustiedosto)\"?"]
         if {$vastaus == "yes"} {
            tallennaHuomautustiedosto
         }
      }
      if {$vastaus != "cancel"} {
         vaihdaKohdistin watch
         suljeDokumenttitiedosto
         vaihdaValikonTila disabled
         vaihdaKohdistin oletus
      }
   }
}

proc suljeDokumenttitiedosto {} {
   global d m

   .tyotila.sivu delete all

   if {[info exists sivukuva]} {
       image delete $sivukuva
   }

   vaihdaPainikkeidenTila disabled
   .navi.naytto configure -text ""

   set m(dokumentti) ""
   set m(dokversio) ""
   set m(huomautustiedosto) ""
   set m(muuttunut) 0
   set m(tekija) ""
   set m(luontipvm) ""

   foreach tieto [array names d] {
      unset d($tieto)
   }
   unset d

   .hIkkuna.teksti configure -state normal
   .hIkkuna.teksti delete 1.0 end
   .hIkkuna.teksti configure -state disabled
   wm withdraw .hIkkuna

   foreach w [winfo children .] {
      switch [winfo class $w] {
         "Raportti-ikkuna" {destroy $w}
         "Seliteikkuna" {destroy $w}
         "Tarkastajaikkuna" {destroy $w}
      }
   }

   bind .tyotila.sivu <Double-1> { }

   asetaIkkunanOtsikko
}

proc valitseHuomautus {huomID} {
   global d

   set sivu [string range [lindex [split $huomID -] 0] 1 end]

   vaihdaKohdistin watch
   avaaMuokkausikkuna $huomID
   if {$sivu != $d(nykysivu)} {
      naytaSivu $sivu
   }
   .tyotila.sivu itemconfigure $huomID -outline black -width 3
   vaihdaKohdistin oletus
}

proc paivitaHuomautusikkuna {} {
   global d k m

   set hi ".hIkkuna"

   if {$d(tarkastajat) == $d(valituttarkastajat)} {
      set rajoitus 0
   } else {
      set rajoitus 1
   }

   vaihdaKohdistin watch

   wm deiconify $hi
   $hi.teksti configure -state normal
   $hi.teksti delete 1.0 end

   set nayta 1
   set i 0
   foreach sivu $d(sivulista) {
      $hi.teksti insert end "[string toupper $k(sivu)] [expr $i + 1]" "s$i sivu"
      $hi.teksti insert end "\n\n"
      $hi.teksti tag bind s$i <Button-1> "naytaSivu $i"
      $hi.teksti tag bind s$i <Enter> "$hi.teksti tag configure s$i -background green"
      $hi.teksti tag bind s$i <Leave> "$hi.teksti tag configure s$i -background {}"
      if {[info exists d($sivu-huom)]} {
         foreach huomID $d($sivu-huom) {
            if {$rajoitus == 1} {
               if {[lsearch $d(valituttarkastajat) $d($huomID-tarkastaja)] != -1} {
                  set nayta 1
               } else {
                  set nayta 0
               }
            }
            if {$nayta == 1} {
               $hi.teksti insert end "$d($huomID-tarkastaja):" "tarkastaja $huomID huom"
               $hi.teksti insert end " $d($huomID-teksti)" "$huomID huom"
               $hi.teksti insert end "\n\n"
            }
            $hi.teksti tag bind $huomID <Button-1> "valitseHuomautus $huomID"
            $hi.teksti tag bind $huomID <Enter> "korostusKayttoon $huomID {ikkuna lista merkki}"
            $hi.teksti tag bind $huomID <Leave> "korostusPois $huomID {ikkuna lista merkki}"
         }
      }
      incr i
   }

   $hi.teksti tag configure sivu -font {Helvetica 12 bold underline}
   $hi.teksti tag configure huom -lmargin1 8 -lmargin2 8
   $hi.teksti tag configure tarkastaja -font {Helvetica 12 bold italic}
   $hi.teksti configure -state disabled

   vaihdaKohdistin oletus
}

proc siirryHuomautusikkunassa {tagi} {
   set kohta [lindex [.hIkkuna.teksti tag ranges $tagi] 0]

   .hIkkuna.teksti see $kohta
}


proc tallenna {} {
   if {[tarkistaMuokkausikkunat] == 0} {
      if {[catch tallennaHuomautustiedosto virhe] != 0} { 
         tk_dialog .ilmo $k(virhe) "$k(kirjoitusvirhe) \"$m(huomautustiedosto)\"" warning 0 "   OK   "
      }
   }
}

proc tallennaHuomautustiedosto {} {
   global d m

   set t [open $m(huomautustiedosto) w]

   vaihdaKohdistin watch

   puts $t "<!-- This file was generated by sfia. Do not edit! -->"
   puts $t "<DCF-VERSION>"
   puts $t "$m(sfia-versio)"
   if {[info exists d(sivulista)]} {
      foreach sivu $d(sivulista) {
         if {[info exists d($sivu-huom)]} {
            foreach huom $d($sivu-huom) {
               puts $t "<COMMENT>"
               puts $t "<COORDS>"
               puts $t "$sivu $d($huom-x) $d($huom-y)"
               puts $t "<TEXT>"
               puts $t "$d($huom-teksti)"
               puts $t "</TEXT>"
               puts $t "<INSPECTOR>"
               puts $t "$d($huom-tarkastaja)"
               puts $t "<DATE>"
               puts $t "$d($huom-pvm)"
               puts $t "<CLASSIFICATION>"
               if {[info exists d(luokitukset)]} {
                  foreach luokka $d(luokitukset) {
                     if {[info exists d($huom-$luokka)]} {
                        if {$d($huom-$luokka) >= 0} {
                           puts $t "$luokka $d($huom-$luokka)"
                        }
                     }
                  }
               }
               puts $t "</CLASSIFICATION>"
               puts $t "<STATUS>"
               puts $t "$d($huom-tila)"
               puts $t "</COMMENT>"
            }
         }
      }
   }
   close $t
   set m(muuttunut) 0

   vaihdaKohdistin oletus
}

proc lueDokumenttitiedosto {tiedosto} {
   global d m rlaskuri vika

   set rlaskuri 0
   set vika 0
   set t [open $tiedosto r]

   vaihdaKohdistin watch

   gets $t rivi; incr rlaskuri
   while {[string toupper $rivi] != "<PAGES>" && ![eof $t] && $vika == 0} {
      switch [string toupper $rivi] {
         "<VERSION>" {
            gets $t rivi; incr rlaskuri
            while {[string range $rivi 0 3] == "<!--" || [string length [string trim $rivi]] == 0} {
               gets $t rivi; incr rlaskuri
            }
            for {set i 0} {$i < [string length $rivi]} {incr i} {
               if {![regexp {[0-9\.]} [string index $rivi $i]]} {
                  set vika 1
               }
            }
            if {$vika == 0} {
               if {$rivi <= $m(sfia-versio)} {
                  set m(dokversio) $rivi
               } else {
                  set vika 1
               }
            }
         }
         "<AUTHOR>" {
            gets $t rivi; incr rlaskuri
            while {[string range $rivi 0 3] == "<!--" || [string length [string trim $rivi]] == 0} {
               gets $t rivi; incr rlaskuri
            }
            if {[string index $rivi 0] == "<"} {
               set vika 2
            } else {
               set m(tekija) $rivi
            }
         }
         "<DATE>" {
            gets $t rivi; incr rlaskuri
            while {[string range $rivi 0 3] == "<!--" || [string length [string trim $rivi]] == 0} {
               gets $t rivi; incr rlaskuri
            }
            if {[llength [split $rivi { }]] == 2} {
               for {set i 0} {$i < [string length $rivi]} {incr i} {
                  if {![regexp {[0-9\.\ ]} [string index $rivi $i]]} {
                     set m(luontipvm) ""
                  }
               }
            } else {
               set m(luontipvm) ""
            }
            if {$vika == 0} {
               set m(luontipvm) $rivi
            }
         }
      }
      gets $t rivi; incr rlaskuri
   }

   if {$vika == 0} {
      foreach tieto {dokversio tekija} {
         if {$m($tieto) == ""} {
            set vika 4
         }
      }
   }

   set slaskuri 0
   while {$vika == 0 && $rivi != "</PAGES>" && ![eof $t]} {
      if {[file exists [file join $d(hakemisto) $rivi]]} {
         lappend d(sivulista) "s$slaskuri"
         set sivu [lindex $d(sivulista) $slaskuri]
         set d($sivu-kuva) $rivi
         incr slaskuri
      } else {
         if {[string range $rivi 0 0] != "<"} {
             set vika 5
         }
      }
      gets $t rivi; incr rlaskuri
   }
   if {$vika == 0 && ![info exists d(sivulista)]} {
      set vika 5
   }

   set llaskuri -1
   while {$vika == 0 && [string toupper $rivi] != "</CLASSIFICATION>" && ![eof $t]} {
      gets $t rivi; incr rlaskuri
      if {$rivi == "<CLASS>"} {
         set alaskuri -1
         incr llaskuri
         lappend d(luokitukset) "l$llaskuri"
         set luokka [lindex $d(luokitukset) $llaskuri]
         while {$rivi != "</CLASS>" && $vika == 0} {
            gets $t rivi; incr rlaskuri
            switch [string toupper $rivi] {
               "<NAME>" {
                  gets $t rivi; incr rlaskuri
                  while {[string range $rivi 0 3] == "<!--" || [string length [string trim $rivi]] == 0} {
                     gets $t rivi; incr rlaskuri
                  }
                  if {[regexp -nocase {[0-9a-z]} [string index $rivi 0]]} {
                     set d($luokka-nimi) $rivi
                  } else {
                     set vika 6
                  }
               }
               "<VALUE>" {
                  if {[info exists d($luokka-nimi)]} {
                     incr alaskuri
                     gets $t rivi; incr rlaskuri
                     while {[string range $rivi 0 3] == "<!--" || [string length [string trim $rivi]] == 0} {
                        gets $t rivi; incr rlaskuri
                     }
                     if {[regexp -nocase {[0-9a-z]} [string index $rivi 0]]} {
                        lappend d($luokka-tiedot) $luokka-$alaskuri
                        set d($luokka-$alaskuri-arvo) $rivi
                     } else {
                        set vika 7
                     }
                  } else {
                     set vika 6
                  }
               }
               "<LEGEND>" {
                  if {[info exists d($luokka-$alaskuri-arvo)]} {
                     gets $t rivi; incr rlaskuri
                     while {[string range $rivi 0 3] == "<!--" || [string length [string trim $rivi]] == 0} {
                        gets $t rivi; incr rlaskuri
                     }
                     if {[regexp -nocase {[0-9a-z]} [string index $rivi 0]]} {
                        set d($luokka-$alaskuri-selite) $rivi
                     } else {
                       set vika 8
                     }
                  } else {
                     set vika 7
                  }
               }
            }
         }
      }
   }
   close $t

   if {$vika == 0} {
      set d(sivumaara) [llength $d(sivulista)]
   }

   vaihdaKohdistin oletus
}

proc lueHuomautustiedosto {tiedosto} {
   global d m rlaskuri vika

   set rlaskuri 0
   set vika 0
   set t [open $tiedosto r]

   vaihdaKohdistin watch

   set hlaskuri -1
   while {![eof $t] && $vika == 0} {
      gets $t rivi; incr rlaskuri
      switch [string toupper $rivi] {
         "<DCF-VERSION>" {
            gets $t rivi; incr rlaskuri
            while {[string index $rivi 0] == "<" || [string length [string trim $rivi]] == 0} {
               gets $t rivi; incr rlaskuri
            }
            for {set i 0} {$i < [string length $rivi]} {incr i} {
               if {![regexp {[0-9\.]} [string index $rivi $i]]} {
                  set vika 20
               }
            }
            if {$vika == 0} {
               if {$rivi <= $m(sfia-versio)} {
                  set d(dcf-versio) $rivi
               } else {
                  set vika 20
               }
            }
         }
         "<COMMENT>" {
            incr hlaskuri
            while {$rivi != "</COMMENT>" && ![eof $t] && $vika == 0} {
               gets $t rivi; incr rlaskuri
               switch $rivi {
                  "<COORDS>" {
                     gets $t rivi; incr rlaskuri
                     while {[string index $rivi 0] == "<" || [string length [string trim $rivi]] == 0} {
                        gets $t rivi; incr rlaskuri
                     }
                     set rivi [split $rivi { }]
                     if {[llength $rivi] == 3 && [regexp {s[0-9]} [lindex $rivi 0]]} {
                        set sivu [lindex $rivi 0]
                        set d($sivu-$hlaskuri-x) [lindex $rivi 1]
                        set d($sivu-$hlaskuri-y) [lindex $rivi 2]
                        lisaaHuomautusListaan $sivu $hlaskuri $d($sivu-$hlaskuri-x) $d($sivu-$hlaskuri-y)
                     } else {
                        set vika 20
                     }
                  }
                  "<TEXT>" {
                     set teksti ""
                     gets $t rivi; incr rlaskuri
                     while {[string toupper $rivi] != "</TEXT>"} {
                        if {[string range $rivi 0 3] != "<!--"} {
                           set teksti "[concat $teksti $rivi]\n"
                        }
                        gets $t rivi; incr rlaskuri
                     }
                     set d($sivu-$hlaskuri-teksti) [string trimright $teksti]
                  }
                  "<INSPECTOR>" {
                     gets $t rivi; incr rlaskuri
                     while {[string index $rivi 0] == "<" || [string length [string trim $rivi]] == 0} {
                        gets $t rivi; incr rlaskuri
                     }
                     if {[string index $rivi 0] == "<"} {
                        set vika 20
                     } else {
                        set d($sivu-$hlaskuri-tarkastaja) $rivi
                        if {[lsearch $d(tarkastajat) $rivi] == -1} {
                           lappend d(tarkastajat) $rivi
                        }
                     }
                  }
                  "<DATE>" {
                     gets $t rivi; incr rlaskuri
                     while {[string index $rivi 0] == "<" || [string length [string trim $rivi]] == 0} {
                        gets $t rivi; incr rlaskuri
                     }
                     if {[llength [split $rivi { }]] == 2} {
                        for {set i 0} {$i < [string length $rivi]} {incr i} {
                           if {![regexp {[0-9\.\ ]} [string index $rivi $i]]} {
                              set vika 20
                           }
                        }
                     } else {
                        set vika 20
                     }
                     if {$vika == 0} {
                        set d($sivu-$hlaskuri-pvm) $rivi
                     }
                  }
                  "<CLASSIFICATION>" {
                     gets $t rivi; incr rlaskuri
                     while {[string toupper $rivi] != "</CLASSIFICATION>"} {
                        if {[string index $rivi 0] != "<" || [string length [string trim $rivi]] == 0} {
                           set rivi [split $rivi { }]
                           set luokka [lindex $rivi 0]
                           set valinta [lindex $rivi 1]
                           set d($sivu-$hlaskuri-$luokka) $valinta
                        }
                        gets $t rivi; incr rlaskuri
                     }
                  }
                  "<STATUS>" {
                     gets $t rivi; incr rlaskuri
                     while {[string index $rivi 0] == "</COMMENT>" || [string length [string trim $rivi]] == 0} {
                        gets $t rivi; incr rlaskuri
                     }
                     if {[regexp {[0-9]} $rivi]} {
                        set d($sivu-$hlaskuri-tila) $rivi
                     } else {
                        set vika 20
                     }
                  }
               }
            }
            if {($vika == 0) && \
                (![info exists d($sivu-$hlaskuri-x)] || \
                ![info exists d($sivu-$hlaskuri-y)] || \
                ![info exists d($sivu-$hlaskuri-teksti)] || \
                ![info exists d($sivu-$hlaskuri-tarkastaja)] || \
                ![info exists d($sivu-$hlaskuri-pvm)] || \
                ![info exists d($sivu-$hlaskuri-tila)])} {
               set vika 20
            }

            if {$vika == 0} {
               lappend tagit "merkki"
               lappend tagit "$sivu-$hlaskuri"
               set d($sivu-$hlaskuri-tagit) $tagit
               unset tagit
            }
         }
      }
   }
   close $t

   if {$vika == 0} {
      set d(tarkastajat) [lsort $d(tarkastajat)]
      set d(valituttarkastajat) $d(tarkastajat)
   }

   vaihdaKohdistin oletus
}

proc avaa {} {
   global d k m vika rlaskuri

   if {[tarkistaMuokkausikkunat] == 0} {
      set filtteri {
         {{Document Definition File} {.ddf}}
      }

      set tiedosto [tk_getOpenFile -title "$k(avaatiedosto)" -filetypes $filtteri]
      if {$tiedosto != ""} {
         if {$m(dokumentti) != ""} {
            sulje
         }

         if {$m(dokumentti) == ""} {
            vaihdaKohdistin watch

            set d(hakemisto) [file dirname $tiedosto]

            lappend d(tarkastajat) $m(kayttaja)
            set d(valituttarkastajat) $d(tarkastajat)

            set komento "lueDokumenttitiedosto $tiedosto"

            if {[catch $komento virhe] == 0} { 
               if {$vika == 0} {
                  set m(dokumentti) $tiedosto

                  set d(nykysivu) 1

                  vaihdaPainikkeidenTila normal

                  vaihdaValikonTila normal

                  bind .tyotila.sivu <Double-1> {
                     lisaaHuomautusmerkki [.tyotila.sivu canvasx %x] [.tyotila.sivu canvasy %y]
                  }

                  set m(huomautustiedosto) "[file join $d(hakemisto) [lindex [split [file tail $m(dokumentti)] .] 0]-$m(kayttaja).dcf]"
                  if {[file exists $m(huomautustiedosto)]} {
                     set komento "lueHuomautustiedosto $m(huomautustiedosto)"
                     if {[catch $komento virhe] != 0} {
                        vaihdaKohdistin oletus
                        tk_dialog .ilmo $k(virhe) "$k(lukuvirhe) \"$m(huomautustiedosto)\":\n\n$virhe" warning 0 "   OK   "
                        sulje
                     }
                  }

                  if {$vika == 0} {
                     paivitaHuomautusikkuna 
                     if {[info exists d(luokitukset)]} {
                        .menu.nayta.n entryconfigure 3 -state normal
                     } else {
                        .menu.nayta.n entryconfigure 3 -state disabled
                     }
                     siirry ensisivu
                     asetaIkkunanKoko
                     asetaIkkunanOtsikko
                  } else {
                     vaihdaKohdistin oletus
                     tk_dialog .ilmo $k(virhe) "$k(lukuvirhe) \"$m(huomautustiedosto)\":\n\n[virheilmoitus $vika]" warning 0 "   OK   "
                     sulje
                  }
               } else {
                  vaihdaKohdistin oletus
                  tk_dialog .ilmo $k(virhe) "$k(lukuvirhe) \"$tiedosto\":\n\n[virheilmoitus $vika]\n\n$k(virherivilla) $rlaskuri ($k(taiaiemmin))" warning 0 "   OK   "
                  sulje
               }
               vaihdaKohdistin oletus
            } else {
               vaihdaKohdistin oletus
               tk_dialog .ilmo $k(virhe) "$k(lukuvirhe) \"$tiedosto\":\n\n$virhe" warning 0 "   OK   "
               sulje
            }
         }
      }
   }
}


proc virheilmoitus {virhenro} {
   global k

   switch $virhenro {
      1 {set virheteksti $k(virheellinenversio)}
      2 {set virheteksti $k(virheellinentekija)}
      3 {set virheteksti $k(virheellinenpaivays)}
      4 {set virheteksti $k(virheellinendokumentintieto)}
      5 {set virheteksti $k(virheellinensivutiedosto)}
      6 {set virheteksti $k(virheellinenluokannimi)}
      7 {set virheteksti $k(virheellinenluokanarvo)}
      8 {set virheteksti $k(virheellinenluokanselite)}
      20 {set virheteksti $k(virheellinentiedosto)}
   }

   return $virheteksti
}

proc avaaHuomautusikkuna {} {
   global k

   set hi .hIkkuna

   if {[winfo exists $hi]} {
      wm deiconify $hi
      raise $hi
   } else {
      toplevel $hi -class "Huomautusikkuna"

      text      $hi.teksti  -background white -height 15 -width 60 -yscroll "$hi.vpalkki set" \
                            -cursor arrow -state disabled -wrap word -font {Helvetica 12}
      scrollbar $hi.vpalkki -orient vertical -command "$hi.teksti yview"
      pack      $hi.vpalkki -side right -fill y -pady 2
      pack      $hi.teksti  -side right -fill both -expand yes -padx 2 -pady 2

      wm title     $hi "$k(huomautuslista)"
      wm geometry  $hi =250x500
      wm protocol  $hi WM_DELETE_WINDOW "wm withdraw $hi"
      wm withdraw  $hi
   }
}

proc avaaMuokkausikkuna {ikkuna} {
   set mi ".$ikkuna"

   vaihdaKohdistin watch

   if {[winfo exists $mi]} {
      wm deiconify $mi
      raise $mi
   } else {
      toplevel $mi -class "Muokkausikkuna"

      luoMuokkausikkuna $mi

      mukautaMuokkausikkuna $mi
   }

   vaihdaKohdistin oletus
}

proc mukautaMuokkausikkuna {mi} {
   global d k m

   set huomID [string range $mi 1 end]

   if {$m(rajoitukset)} {
      if {[string tolower $m(kayttaja)] != [string tolower $d($huomID-tarkastaja)]} {
         $mi.txtkehys.teksti configure -state disabled
         $mi.p.tallennaJaSulje configure -state disabled
         $mi.p.tallennaAlaSulje configure -state disabled
         if {[info exists d(luokitukset)]} {
            foreach nappiryhma $d(luokitukset) {
               foreach nappi [winfo children $mi.rn.$nappiryhma] {
                  if {[$nappi cget -text] != "$d($nappiryhma-nimi):"} {
                     $nappi configure -state disabled
                  }
               }
            }
         }
      }
      if {[string tolower $m(kayttaja)] == [string tolower $m(tekija)]} {
         $mi.txtkehys.teksti configure -state normal
         $mi.p.tallennaJaSulje configure -state normal
         $mi.p.tallennaAlaSulje configure -state normal
      }
   }

   wm title     $mi "$k(muokkaahuomautusta)"
   wm geometry  $mi "400x350"
   wm deiconify $mi
   wm protocol  $mi WM_DELETE_WINDOW "$mi.p.hylkaaJaSulje invoke"
   focus $mi.txtkehys.teksti
   raise $mi
}

proc luoMuokkausikkuna {mi} {
   global d k m valinta

   set huomID [string range $mi 1 end]

   frame     $mi.tiedot           -relief sunken -borderwidth 2
   label     $mi.tiedot.otsikko1  -text $k(tarkastaja):
   label     $mi.tiedot.tekija    -text $d($huomID-tarkastaja) -anchor w
   label     $mi.tiedot.otsikko2  -text $k(paivays):
   label     $mi.tiedot.pvm       -text $d($huomID-pvm) -anchor w
   label     $mi.tiedot.otsikko3  -text $k(sivu):
   label     $mi.tiedot.sivu      -text [expr $d(nykysivu) + 1] -anchor w
   grid      $mi.tiedot.otsikko1  -row 0 -column 0 -sticky e
   grid      $mi.tiedot.tekija    -row 0 -column 1 -sticky ew
   grid      $mi.tiedot.otsikko2  -row 1 -column 0 -sticky e
   grid      $mi.tiedot.pvm       -row 1 -column 1 -sticky ew
   grid      $mi.tiedot.otsikko3  -row 1 -column 2 -sticky e
   grid      $mi.tiedot.sivu      -row 1 -column 3 -sticky ew
   grid configure $mi.tiedot.tekija -columnspan 4
   grid columnconfigure $mi.tiedot 1 -weight 1
   pack      $mi.tiedot           -side top -fill x

   frame     $mi.rn               -relief flat -borderwidth 0

   if {[info exists d(luokitukset)]} {
      foreach luokka $d(luokitukset) {
         frame $mi.rn.$luokka -relief groove -borderwidth 2
         label $mi.rn.$luokka.otsikko -text "$d($luokka-nimi):"
         pack  $mi.rn.$luokka.otsikko -side top -anchor nw
         if {[info exists d($luokka-tiedot)]} {
            for {set i 0} {$i < [llength $d($luokka-tiedot)]} {incr i} {
               radiobutton $mi.rn.$luokka.$i -text $d($luokka-$i-arvo) -variable valinta($luokka-$huomID) -value $i
               pack $mi.rn.$luokka.$i -side top -anchor nw
            }
            if {[info exists d($huomID-$luokka)]} {
               if {$d($huomID-$luokka) >= 0} {
                  $mi.rn.$luokka.$d($huomID-$luokka) invoke
               }
            }
         }
      }
   }

   if {$m(tekija) == $m(kayttaja) || !$m(rajoitukset)} {
      frame $mi.rn.tila -relief groove -borderwidth 2
      label $mi.rn.tila.otsikko -text $k(kasittelyntila):
      radiobutton $mi.rn.tila.k0 -text $k(kasitelty) -foreground green3 -variable valinta(t-$huomID) -value 0
      radiobutton $mi.rn.tila.k1 -text $k(huomioitu) -foreground yellow -variable valinta(t-$huomID) -value 1
      radiobutton $mi.rn.tila.k2 -text $k(kasittelematta) -foreground red1 -variable valinta(t-$huomID) -value 2
      pack $mi.rn.tila.otsikko \
           $mi.rn.tila.k0 \
           $mi.rn.tila.k1 \
           $mi.rn.tila.k2 -side top -anchor nw
      $mi.rn.tila.k$d($huomID-tila) invoke
   }

   frame     $mi.p                  -relief groove -borderwidth 2
   button    $mi.p.tallennaJaSulje  -text $k(hyvaksyjasulje) -command "miHyvaksy $mi 1"
   button    $mi.p.tallennaAlaSulje -text $k(hyvaksyalasulje) -command "miHyvaksy $mi 0"
   button    $mi.p.hylkaaJaSulje -text $k(hylkaajasulje) -command "miSulje $mi"
   pack      $mi.p.tallennaJaSulje \
             $mi.p.tallennaAlaSulje \
             $mi.p.hylkaaJaSulje -side top -fill x

   if {[info exists d(luokitukset)]} {
      for {set i 0} {$i < [llength $d(luokitukset)]} {incr i} {
         grid $mi.rn.[lindex $d(luokitukset) $i]    -row 0 -column $i -sticky nw
      }
   } else {
      set i -1
   }
   if {$m(tekija) == $m(kayttaja) || !$m(rajoitukset)} {
      grid $mi.rn.tila -row 0 -column [incr i] -sticky nw
   }
   pack      $mi.p           -side bottom -fill x -expand yes
   pack      $mi.rn          -side bottom

   frame     $mi.txtkehys         -relief sunken -borderwidth 2
   text      $mi.txtkehys.teksti  -background white -yscroll "$mi.txtkehys.vpalkki set" -wrap word
   scrollbar $mi.txtkehys.vpalkki -orient vertical -command "$mi.txtkehys.teksti yview"
   pack      $mi.txtkehys.vpalkki -side right -fill y -pady 2
   pack      $mi.txtkehys.teksti  -side right -fill both -expand yes -padx 2 -pady 2

   pack      $mi.txtkehys         -side top -fill both -expand yes

   $mi.txtkehys.teksti insert end $d($huomID-teksti)

   bind $mi <Enter> "korostusKayttoon $huomID {lista merkki}"
   bind $mi <Leave> "korostusPois $huomID {lista merkki}"
}

proc miHyvaksy {mi sulje} {
   global d m valinta

   set huomID [string range $mi 1 end]

   vaihdaKohdistin watch

   set d($huomID-pvm) [clock format [clock seconds] -format "%d.%m.%Y %H.%M"]
   set $mi.tiedot.pvm $d($huomID-pvm)
   set d($huomID-teksti) [string trimright [$mi.txtkehys.teksti get 1.0 end]]
   if {[info exists d(luokitukset)]} {
      foreach luokka $d(luokitukset) {
         if {$valinta($luokka-$huomID) >= 0} {
            set d($huomID-$luokka) $valinta($luokka-$huomID)
         }
      }
   }
   if {[info exists valinta(t-$huomID)]} {
      vaihdaHuomautuksenTila $huomID $valinta(t-$huomID)
   } else {
      set d($huomID-tila) 2
   }
   incr m(muuttunut)
   paivitaHuomautusikkuna
   siirryHuomautusikkunassa $huomID

   if {$sulje == 1} {
      if {[info exists d(luokitukset)]} {
         foreach luokka $d(luokitukset) {
            unset valinta($luokka-$huomID)
         }
      }
      korostusPois $huomID {lista merkki} 
      destroy $mi
   }

   vaihdaKohdistin oletus
}

proc miSulje {mi} {
   global d k m valinta

   set huomID [string range $mi 1 end]
   set vastaus "no"

   vaihdaKohdistin watch

   if {[string tolower $m(kayttaja)] == [string tolower $d($huomID-tarkastaja)] && \
       [string trim [$mi.txtkehys.teksti get 1.0 end]] == ""} {
      set vastaus [tk_messageBox -icon question -type yesnocancel -title "$k(sulje)" -parent $mi \
                  -message "$k(huomautustekstipuuttuu)\n$k(huomautuksenpoistaminen2)"]
      if {$vastaus == "yes"} {
         poistaHuomautusmerkki $huomID
      }
   }

   if {$vastaus != "cancel" && [winfo exists $mi]} {
      korostusPois $huomID {lista merkki}
      destroy $mi
   }

   if {$vastaus != "cancel"} {
      if {[info exists d(luokitukset)]} {
         foreach luokka $d(luokitukset) {
            unset valinta($luokka-$huomID)
         }
      }
   }

   vaihdaKohdistin oletus
}

proc paivitaSivu {} {
   global d

   .tyotila.sivu delete merkki
   naytaHuomautusmerkit $d(nykysivu)
}


proc vaihdaHuomautuksenTila {huomID tila} {
   global d m

   set d($huomID-tila) $tila
   set sivu [string range [lindex [split $huomID -] 0] 1 end]

   if {$d(nykysivu) == $sivu} {
      .tyotila.sivu delete $huomID
      piirraHuomautusmerkki $d($huomID-x) $d($huomID-y) $d($huomID-tagit)
   }
   if {[winfo exists .$huomID]} {
      .$huomID.rn.tila.k$d($huomID-tila) invoke
   }
   incr m(muuttunut)
}

proc naytaArvotJaSelitteet {} {
   global d k

   set si ".sIkkuna"

   vaihdaKohdistin watch

   if {[winfo exists $si]} {
      wm deiconify $si
      raise $si
   } else {
      toplevel $si -class "Seliteikkuna"

      frame     $si.lomake         -relief sunken -borderwidth 1
      scrollbar $si.lomake.vpalkki -command "$si.lomake.alue yview"
      pack      $si.lomake.vpalkki -side right -fill y
      canvas    $si.lomake.alue    -yscrollcommand "$si.lomake.vpalkki set"
      pack      $si.lomake.alue    -side left -fill both -expand yes
      frame     $si.lomake.alue.luokat
      $si.lomake.alue create window 0 0 -anchor nw -window $si.lomake.alue.luokat

      set paikka $si.lomake.alue.luokat
      bind $paikka <Configure> "asetaSeliteikkunanKoko $si.lomake.alue"

      for {set i 0} {$i < [llength $d(luokitukset)]} {incr i} {
         set luokka [lindex $d(luokitukset) $i]
         frame $paikka.l$i          -relief solid -borderwidth 1
         pack  $paikka.l$i          -side top -anchor w -padx 2 -pady 2 -fill x -expand yes
         frame $paikka.l$i.s        -relief flat -borderwidth 0
         pack  $paikka.l$i.s        -side left -anchor w -padx 2 -pady 2
         label $paikka.l$i.s.nimi$i -text "[string toupper $d($luokka-nimi)]" -justify left
         grid  $paikka.l$i.s.nimi$i -row 0 -column 0 -columnspan 2 -sticky nw
         if {[info exists d($luokka-tiedot)]} {
            for {set j 0} {$j < [llength $d($luokka-tiedot)]} {incr j} {
               set tieto [lindex $d($luokka-tiedot) $j]
               label $paikka.l$i.s.arvo$j   -text "$d($tieto-arvo):" -justify left
               grid  $paikka.l$i.s.arvo$j   -row [expr $j + 1] -column 0 -sticky w
               if {[info exists d($tieto-selite)]} {
                  label $paikka.l$i.s.selite$j -text "$d($tieto-selite)" -justify left
                  grid  $paikka.l$i.s.selite$j -row [expr $j + 1] -column 1 -sticky w
                  grid  columnconfigure $paikka.l$i.s.selite$j 1 -weight 1
               }
            }
         }
      }
      button $si.sulje -text $k(sulje2) -width 8 -command "wm withdraw $si"
      pack $si.sulje -side bottom -anchor s -pady 4

      pack $si.lomake -side top -anchor nw -fill both -expand yes -padx 2 -pady 2

      wm title $si "$k(arvotjaselitteet)"
      raise $si
   }

   vaihdaKohdistin oletus
}

proc asetaSeliteikkunanKoko {alue} {
   set koko [$alue bbox all]
   set leveys [winfo width $alue.luokat]
   set korkeus [winfo height $alue.luokat]

   $alue configure -width $leveys -height $korkeus -scrollregion $koko -yscrollincrement 0.5c
}

proc luoRaportti {tyyppi} {
   global d k m tcl_platform tulostus

   if {[onHuomautuksia]} {
      vaihdaKohdistin watch

      if {$tyyppi == "kaikki"} {
         set ri .khraportti-ikkuna
      } else {
         set ri .yvraportti-ikkuna
      }

      if {[winfo exists $ri]} {
         wm deiconify $ri
         raise $ri
      } else {
         toplevel $ri -class "Raportti-ikkuna"

         if {![info exists tulostus]} {
            set tulostus "lpr"
         }

         frame  $ri.p                 -relief flat
         pack   $ri.p                 -side bottom -anchor s -fill x
         button $ri.p.tallenna        -text $k(tallenna) -width 8 -command "tallennaRaportti $ri"
         button $ri.p.tulosta         -text $k(tulosta) -width 8
         label  $ri.p.tulostusotsikko -text "$k(tulostuskomento):"
         entry  $ri.p.tulostuskomento -relief sunken -width 20
         button $ri.p.sulje           -text $k(sulje2) -width 8 -command "destroy $ri"
         pack   $ri.p.tallenna        -side left -padx 2 -pady 4
         if {$tcl_platform(platform) == "unix"} {
            pack $ri.p.tulostusotsikko \
                 $ri.p.tulostuskomento \
                 $ri.p.tulosta        -side left -padx 2 -pady 4
         }
         pack   $ri.p.sulje           -side right -padx 2 -pady 4

         frame     $ri.t         -relief sunken -borderwidth 2
         text      $ri.t.teksti  -background white -yscroll "$ri.t.vpalkki set" -wrap word -font {Courier 10}
         scrollbar $ri.t.vpalkki -orient vertical -command "$ri.t.teksti yview"
         pack      $ri.t.vpalkki -side right -fill y -pady 2
         pack      $ri.t.teksti  -side right -fill both -expand yes -padx 2 -pady 2
         pack      $ri.t         -side top -fill both -expand yes

         $ri.p.tulostuskomento insert end $tulostus
         $ri.p.tulosta configure -command "tulostaRaportti $ri.p.tulostuskomento $ri.t.teksti"

         bind $ri.p.tulostuskomento <KeyPress> "if {[regexp "\r" "%A"]} {tulostaRaportti $ri.p.tulostuskomento $ri.t.teksti}"

         wm protocol $ri WM_DELETE_WINDOW "$ri.p.sulje invoke"
      }

      $ri.t.teksti configure -state normal
      $ri.t.teksti delete 1.0 end
      $ri.t.teksti insert end "  $k(dokumentti): $m(dokumentti)\n"
      $ri.t.teksti insert end "  $k(tekija): $m(tekija)\t$k(paivays): $m(luontipvm)\n\n"
      $ri.t.teksti insert end "[lisaaMerkkeja "=" 70]"

      switch $tyyppi {
         "kaikki" {
            raporttiKaikkiHuomautukset $ri.t.teksti
            wm title $ri "$k(raportti) - $k(kaikkihuomautukset)"
      }
         "yhteenveto" {
            raporttiYhteenveto $ri.t.teksti
            wm title $ri "$k(raportti) - $k(yhteenveto)"
         }
      }
      $ri.t.teksti configure -state disabled

      vaihdaKohdistin oletus
   } else {
      foreach ikkuna [winfo children .] {
         if {[winfo class $ikkuna] == "Raportti-ikkuna"} {
            destroy $ikkuna
         }
      }
      tk_dialog .ilmo $k(eiraportoitavaa) $k(eihuomautuksia) info 0 "   OK   "
   }
}

proc onHuomautuksia {} {
   global d

   set on 0

   for {set i 0} {$i < [llength $d(sivulista)] && $on == 0} {incr i} {
      if {[info exists d([lindex $d(sivulista) $i]-huom)]} {
         set on 1
         break
      }
   }
   return $on
}


proc raporttiKaikkiHuomautukset {txt} {
   global d k

   vaihdaKohdistin oletus

   $txt insert 1.0 "[string toupper $k(kaikkihuomautukset)]\n\n" otsikko
   foreach sivuID $d(sivulista) {
      if {[info exists d($sivuID-huom)]} {
         foreach huomID $d($sivuID-huom) {
            $txt insert end "\n\n$k(tarkastaja): $d($huomID-tarkastaja)"
            $txt insert end "\t$k(paivays): $d($huomID-pvm)"
            $txt insert end "\t$k(sivu): [expr [string range $sivuID 1 end] + 1]\n"
            $txt insert end "$d($huomID-teksti)\n" teksti
            if {[info exists d(luokitukset)]} {
               foreach luokitus $d(luokitukset) {
                  $txt insert end "$d($luokitus-nimi): "
                  if {[info exists d($huomID-$luokitus)]} {
                     $txt insert end "$d($luokitus-$d($huomID-$luokitus)-arvo)\n"
                  } else {
                     $txt insert end "-\n"
                  }
               }
            }
            $txt insert end "$k(kasittelyntila): "
            switch $d($huomID-tila) {
               "0" {$txt insert end "$k(kasitelty)\n"}
               "1" {$txt insert end "$k(huomioitu)\n"}
               "2" {$txt insert end "$k(kasittelematta)\n"}
            } 
            $txt insert end "[lisaaMerkkeja "_" 70]"
         }
      }
   }

   $txt tag configure "teksti" -spacing1 0.1c -spacing3 0.1c -lmargin1 0.2c -lmargin2 0.2c

   vaihdaKohdistin oletus
}

proc raporttiYhteenveto {txt} {
   global d k

   vaihdaKohdistin watch

   $txt insert 1.0 "[string toupper $k(yhteenveto)]\n\n" otsikko
   if {[info exists d(luokitukset)]} {
      set max [string length $k(eivalittu)]
      foreach luokka $d(luokitukset) {
         set l($luokka-valitsematon-0) 0
         set l($luokka-valitsematon-1) 0
         set l($luokka-valitsematon-2) 0
         foreach tieto $d($luokka-tiedot) {
            set l($tieto-0) 0
            set l($tieto-1) 0
            set l($tieto-2) 0
            set pituus [string length $d($tieto-arvo)]
            if {$pituus > $max} {
               set max $pituus
            }
         }
      }
      foreach sivu $d(sivulista) {
         if {[info exists d($sivu-huom)]} {
            foreach huom $d($sivu-huom) {
               foreach luokka $d(luokitukset) {
                  if {[info exists d($huom-$luokka)]} {
                     incr l($luokka-$d($huom-$luokka)-$d($huom-tila))
                  } else {
                     incr l($luokka-valitsematon-$d($huom-tila))
                  }
               }
            }
         }
      }
      foreach luokka $d(luokitukset) {
         set tila(0) 0
         set tila(1) 0
         set tila(2) 0
         set tila(3) 0
         $txt insert end "\n\n$d($luokka-nimi)\n"
         $txt insert end "[lisaaMerkkeja " " [expr $max + 5]]"
         $txt insert end "$k(kasitelty)   $k(huomioitu)   $k(kasittelematta)   $k(yhteensa)\n"
         foreach tieto $d($luokka-tiedot) {
            set riviyht 0
            $txt insert end "$d($tieto-arvo)"
            $txt insert end "[lisaaMerkkeja " " [expr $max - [string length $d($tieto-arvo)]]]"
            for {set i 0} {$i <= 2} {incr i} {
               $txt insert end "[tasaaTeksti $l($tieto-$i)]"
               set tila($i) [expr $tila($i) + $l($tieto-$i)]
               set riviyht [expr $riviyht + $l($tieto-$i)]
            }
            $txt insert end "[tasaaTeksti $riviyht]\n"
            set tila(3) [expr $tila(3) + $riviyht]
         }
         set riviyht 0
         $txt insert end "$k(eivalittu)"
         $txt insert end "[lisaaMerkkeja " " [expr $max - [string length $k(eivalittu)]]]"
         for {set i 0} {$i <=2} {incr i} {
            $txt insert end "[tasaaTeksti $l($luokka-valitsematon-$i)]"
            set tila($i) [expr $tila($i) + $l($luokka-valitsematon-$i)]
            set riviyht [expr $riviyht + $l($luokka-valitsematon-$i)]
         }
         $txt insert end "[tasaaTeksti $riviyht]\n"
         set tila(3) [expr $tila(3) + $riviyht]
         $txt insert end "$k(yhteensa)"
         $txt insert end "[lisaaMerkkeja " " [expr $max - [string length $k(yhteensa)]]]"
         for {set i 0} {$i <= 3} {incr i} {
            $txt insert end "[tasaaTeksti $tila($i)]"
         }
         $txt insert end "\n[lisaaMerkkeja "_" 70]"
      }
   } else {
      set kaikki(0) 0
      set kaikki(1) 0
      set kaikki(2) 0
      foreach sivu $d(sivulista) {
         if {[info exists d($sivu-huom)]} {
            foreach huom $d($sivu-huom) {
               incr kaikki($d($huom-tila))
            }
         }
      }
      set kaikki(3) [expr $kaikki(0) + $kaikki(1) + $kaikki(2)]
      set max [string length $k(yhteensa)]
      $txt insert end "\n\n$k(kaikkihuomautukset)\n"
      $txt insert end "[lisaaMerkkeja " " [expr $max + 5]]"
      $txt insert end "$k(kasitelty)   $k(huomioitu)   $k(kasittelematta)   $k(yhteensa)\n"
      $txt insert end "[string toupper $k(yhteensa)]"
      $txt insert end "[lisaaMerkkeja " " [expr $max -[string length $k(yhteensa)]]]"
      for {set i 0} {$i <= 3} {incr i} {
         $txt insert end "[tasaaTeksti $kaikki($i)]"
      }
   }

   vaihdaKohdistin oletus
}

proc tasaaTeksti {luku} {
   set tyhjeet 12
   set pituus [string length $luku]
   set vali [lisaaMerkkeja " " [expr $tyhjeet - $pituus]]

   return "$vali$luku"
}

proc lisaaMerkkeja {merkki pituus} {
   set mjono ""
   
   for {set i 0} {$i < $pituus} {incr i} {
      set mjono "$mjono$merkki"
   }

   return $mjono
}

proc tallennaRaportti {raportti} {
   global k

   set filtteri {
      {{Text Files} {*.txt}}
      {{All Files} {*}}
   }

   set tiedosto [tk_getSaveFile -title "$k(tallenna)" -parent $raportti -filetypes $filtteri]
   if {$tiedosto != ""} {
      vaihdaKohdistin watch
      set t [open $tiedosto w]
      puts $t [$raportti.t.teksti get 1.0 end]
      close $t
      vaihdaKohdistin oletus
   }
}

proc tulostaRaportti {komento tekstikentta} {
   global tulostus

   if {[$komento get] == ""} {
      $komento insert end "lpr"
   }
   set tulostus [$komento get]

   eval exec [$komento get] << [list [$tekstikentta get 1.0 end]]
}


proc valitseTarkastajat {} {
   global d k m

   set ti .tarkastajaIkkuna

   vaihdaKohdistin watch

   if {[winfo exists $ti]} {
      wm deiconify $ti
      raise $ti
   } else {
      toplevel $ti -class "Tarkastajaikkuna"

      frame       $ti.rn         -relief flat -borderwidth 0
      label       $ti.rn.otsikko -text $k(valitsetarkastajat2)
      radiobutton $ti.rn.0       -text $k(kaikki) -variable valittu -value 0 \
       -command {
          foreach nimi $d(tarkastajat) {
             .tarkastajaIkkuna.vr.$nimi configure -state disabled
          }
       }
      radiobutton $ti.rn.1       -text $k(valitse): -variable valittu -value 1 \
       -command {
          foreach nimi $d(tarkastajat) {
             .tarkastajaIkkuna.vr.$nimi configure -state normal
          }
       }
      pack $ti.rn.otsikko -side top -anchor nw -padx 2
      pack $ti.rn.0       -side top -anchor nw -padx 2
      pack $ti.rn.1       -side top -anchor nw -padx 2

      frame $ti.vr -relief groove -borderwidth 2
      set i 0
      foreach nimi $d(tarkastajat) {
         checkbutton $ti.vr.$nimi -text $nimi -variable tarkastaja($i)
         pack        $ti.vr.$nimi -side top -anchor w
         incr i
      }

      button $ti.ok -text "OK" -width 8 \
       -command {
          if {$valittu == 0} {
             set d(valituttarkastajat) $d(tarkastajat)
          } else {
             set d(valituttarkastajat) ""
             set i 0
             foreach nimi $d(tarkastajat) {
                if {$tarkastaja($i) == 1} {
                   lappend d(valituttarkastajat) $nimi
                }
                incr i
             }
          }
          if {[lsearch $d(valituttarkastajat) $m(kayttaja)] == -1} {
             bind .tyotila.sivu <Double-1> {}
          } else {
             bind .tyotila.sivu <Double-1> {
                 lisaaHuomautusmerkki [.tyotila.sivu canvasx %x] [.tyotila.sivu canvasy %y]
             }
          }
          paivitaSivu
          paivitaHuomautusikkuna
          destroy .tarkastajaIkkuna
       }
      button $ti.peru -text $k(peruuta) -width 8 -command "destroy $ti"

      pack $ti.rn   -side top -fill x -expand yes
      pack $ti.vr   -side left -anchor nw -padx 2
      pack $ti.peru -side right -anchor s -padx 2 -pady 2
      pack $ti.ok   -side right -anchor s -padx 2 -pady 2

      if {$d(tarkastajat) == $d(valituttarkastajat)} {
         $ti.rn.0 invoke
      } else {
         $ti.rn.1 invoke
         set i 0
         foreach nimi $d(tarkastajat) {
            $ti.vr.$nimi configure -state normal
            if {[lsearch $d(valituttarkastajat) $nimi] != -1} {
               set tarkastaja($i) 1
            } else {
               set tarkastaja($i) 0
            }
            incr i
         }
      }
      wm title     $ti "$k(valitsetarkastajat)"
      wm protocol  $ti WM_DELETE_WINDOW "$ti.peru invoke"
   }

   vaihdaKohdistin oletus
}

proc avaaOhjeikkuna {} {
   global k

   set oi .oIkkuna

   if {[winfo exists $oi]} {
      wm deiconify $oi
      raise $oi
   } else {
      toplevel $oi -class "Ohjeikkuna"

      frame     $oi.painike
      button    $oi.painike.sulje   -text $k(sulje2) -width 20 -command "wm withdraw $oi"
      pack      $oi.painike         -side bottom -fill x
      pack      $oi.painike.sulje   -side right -padx 20 -pady 4

      frame     $oi.teksti
      text      $oi.teksti.sisallys -background white -yscroll "$oi.teksti.vpalkki1 set" \
                                    -cursor arrow -width 50 -wrap word
      scrollbar $oi.teksti.vpalkki1 -orient vertical -command "$oi.teksti.sisallys yview"
      text      $oi.teksti.ohje     -background white -yscroll "$oi.teksti.vpalkki2 set" \
                                    -cursor arrow -width 50 -wrap word
      scrollbar $oi.teksti.vpalkki2 -orient vertical -command "$oi.teksti.ohje yview"
      pack      $oi.teksti          -side bottom -fill both -expand yes
      pack      $oi.teksti.vpalkki2 -side right -fill y -pady 2
      pack      $oi.teksti.ohje     -side right -fill both -expand yes -padx 2 -pady 2
      pack      $oi.teksti.vpalkki1 -side right -fill y -pady 2
      pack      $oi.teksti.sisallys -side right -fill both -expand no -padx 2 -pady 2

      wm title     $oi "$k(ohje)"
      wm geometry  $oi =500x400
      wm protocol  $oi WM_DELETE_WINDOW "$oi.painike.sulje invoke"

      naytaOhjeenSisallys
      naytaOhjeenTeksti sfia
   }
}

proc naytaOhjeenSisallys {} {
   set s .oIkkuna.teksti.sisallys
   set i 0

   $s configure -state normal

   $s delete 1.0 end

   $s insert end "sfia\n" "linkki$i sfia"; incr i
   $s insert end "Dokumentin avaaminen\n" "linkki$i avaa";  incr i
   $s insert end "Dokumentissa liikkuminen\n" "linkki$i navi"; incr i
   $s insert end "Huomautuksen lisminen\n" "linkki$i lisaa"; incr i
   $s insert end "Huomautuksen muokkaaminen/nyttminen\n" "linkki$i muokkaa"; incr i
   $s insert end "Huomautuksen poistaminen\n" "linkki$i poista"; incr i
   $s insert end "Raportointi\n" "linkki$i raportti"; incr i
   $s insert end "Huomautusten tallentaminen\n" "linkki$i tallenna"; incr i
   $s insert end "Ohjelman lopettaminen\n" "linkki$i lopeta";  incr i
   $s insert end "Kytttapausesimerkki\n" "linkki$i esimerkki"

   for {set i 0} {$i <= 10} {incr i} {
      $s tag configure linkki$i -foreground red -underline 1 -lmargin1 2 -lmargin2 2 -spacing1 2 -spacing3 2 -font {Helvetica 10}
      $s tag bind linkki$i <Enter> "$s tag configure linkki$i -foreground blue"
      $s tag bind linkki$i <Leave> "$s tag configure linkki$i -foreground red"
   }

   for {set i 1} {$i <= 10} {incr i} {
      $s tag configure linkki$i -lmargin1 10 -lmargin2 10
   }

   $s tag bind sfia <Button-1> "naytaOhjeenTeksti sfia"
   $s tag bind avaa <Button-1> "naytaOhjeenTeksti avaa"
   $s tag bind navi <Button-1> "naytaOhjeenTeksti navi"
   $s tag bind lisaa <Button-1> "naytaOhjeenTeksti lisaa"
   $s tag bind muokkaa <Button-1> "naytaOhjeenTeksti muokkaa"
   $s tag bind poista <Button-1> "naytaOhjeenTeksti poista"
   $s tag bind raportti <Button-1> "naytaOhjeenTeksti raportti"
   $s tag bind tallenna <Button-1> "naytaOhjeenTeksti tallenna"
   $s tag bind lopeta <Button-1> "naytaOhjeenTeksti lopeta"
   $s tag bind esimerkki <Button-1> "naytaOhjeenTeksti esimerkki"

   $s configure -state disabled
}

proc naytaOhjeenTeksti {ohje} {
   set o .oIkkuna.teksti.ohje
   set i 0

   $o configure -state normal

   $o delete 1.0 end

   switch $ohje {
      sfia {
         $o insert end "sfia - software for inspection automation\n\n" "teksti otsikko"
         $o insert end "sfia" "teksti lihavoitu"
         $o insert end " (software for inspection automation) on apuvline dokumenttien ja " teksti
         $o insert end "ohjelmakoodin tarkastamiseen.\n\n" teksti
         $o insert end "sfia:lla voidaan tarkastaa mit tahansa asiakirjoja, joiden sivut on " teksti
         $o insert end "muutettu gif-muotoisiksi kuvatiedostoiksi. Tarkastaja voi " teksti
         $o insert end "list" "teksti linkki$i lisaa"; incr i
         $o insert end " asiakirjoihin erilaisia huomautuksia ja asettaa niille erilaisia " teksti
         $o insert end "valmiita arvoja dokumentin tekijn mahdollisesti mrittelemist " teksti
         $o insert end "luokituksista. Ohjelmisto ei aseta rajoituksia tarkastajien tai " teksti
         $o insert end "huomautusten mrlle.\n\n" teksti
         $o insert end "sfia:n avulla tarkastajat voivat " teksti
         $o insert end "muokata" "teksti linkki$i muokkaa"; incr i
         $o insert end " tai " teksti
         $o insert end "poistaa" "teksti linkki$i poista"; incr i
         $o insert end " tekemin huomautuksia sek katsoa muiden tekemi huomautuksia. " teksti
         $o insert end "dokumentin tekij voi kyd lpi kaikkien tarkastajien tekemt " teksti
         $o insert end "huomautukset, muokata niit sek tehd niist erilaisia " teksti
         $o insert end "raportteja" "teksti linkki$i raportti"; incr i
         $o insert end ".\n\n." teksti
      }
      avaa {
         $o insert end "Dokumentin avaaminen\n\n" "teksti otsikko"
         $o insert end "Valitse " teksti
         $o insert end "Tiedosto/Avaa..." "teksti lihavoitu"
         $o insert end " ja etsi haluamasi .ddf-tiedosto (Document Definition File, " teksti
         $o insert end "dokumentin mrittelytiedosto). Napsauta Avaa-painiketta, jolloin " teksti
         $o insert end "sfia lukee tiedoston sislln. Ohjelma etsii sen jlkeen automaattisesti " teksti
         $o insert end "dokumenttiin liittyvn .dcf-huomautustiedoston (Document Comment File, " teksti
         $o insert end "dokumentin huomautustiedosto) ja lukee mys sen tiedot. Jos tiedostoissa " teksti
         $o insert end "oli virhe, sfia nytt virheilmoituksen; muussa tapauksessa se tuo " teksti
         $o insert end "nkyville dokumentin ensimmisen sivun mahdollisine huomautuksineen.\n\n" teksti
         $o insert end "Jos sfia:n tytilassa on jo avattu dokumentti ja sen huomautuksiin on " teksti
         $o insert end "tehty muutoksia, ohjelma kysyy luvan muutosten tallentamiseen ennen " teksti
         $o insert end "uuden tiedoston avausta.\n\n" teksti
      }
      navi {
         $o insert end "Dokumentissa liikkuminen\n\n" "teksti otsikko"
         $o insert end "Pikkunan alareunassa on nelj navigointipainiketta, joilla voit " teksti
         $o insert end "liikkua sivulta toiselle. Painikkeet toimivat seuraavasti:\n\n" teksti
         $o insert end "  " teksti
         $o insert end " |<  " "teksti harmaa"
         $o insert end " - ensimmiselle sivulle\n\n" teksti
         $o insert end "  " teksti
         $o insert end "  <  " "teksti harmaa"
         $o insert end " - edelliselle sivulle\n\n" teksti
         $o insert end "  " teksti
         $o insert end "  >  " "teksti harmaa"
         $o insert end " - seuraavalle sivulle\n\n" teksti
         $o insert end "  " teksti
         $o insert end "  >| " "teksti harmaa"
         $o insert end " - viimeiselle sivulle\n\n" teksti
         $o insert end "Niden lisksi voit siirty suoraan haluamallesi sivulle kirjoittamalla " teksti
         $o insert end "sivun numeron painikkeiden vieress olevaan kenttn ja painamalla Enter-" teksti
         $o insert end "nppint.\n" teksti
      }
      lisaa {
         $o insert end "Huomautuksen lisminen\n\n" "teksti otsikko"
         $o insert end "Voit list sivulle huomautuksen kaksoisnapsauttamalla hiiren ykkspainiketta. " teksti
         $o insert end "sfia lis napsautuskohtaan punaisen huomautusmerkin ja aukaisee nkyville " teksti
         $o insert end "muokkausikkunan. Ikkunassa ovat valmiina kyttjtunnuksesi, pivmr ja " teksti
         $o insert end "kellonaika sek sen sivun numero, jolla huomautus sijaitsee. Varsinaiselle " teksti
         $o insert end "huomautukselle on tekstikentt, johon voit kirjoittaa haluamasi pituisen tekstin." teksti
         $o insert end "Jos dokumentin tekij on mritellyt erilaisia luokituksia huomautuksille, " teksti
         $o insert end "ne nkyvt radionappiryhmin huomautuskentn alla. Voit valita niist haluamasi " teksti
         $o insert end "arvot.\n\n" teksti
      }
      muokkaa {
         $o insert end "Huomautuksen muokkaaminen/nyttminen\n\n" "teksti otsikko"
         $o insert end "Voit muokata vain itse tekemisi huomautuksia. Napsauta merkki hiiren " teksti
         $o insert end "oikeanpuoleisella painikkeella ja valitse komento " teksti
         $o insert end "Muokkaa" "teksti lihavoitu"
         $o insert end " (jos huomautus on sinun tekemsi) tai " teksti
         $o insert end "Nyt" "teksti lihavoitu"
         $o insert end " (jos huomautus on jonkun muun tekem). Ohjelma avaa huomautuksen muokkausikkunan, " teksti
         $o insert end "jossa voit joko\n" teksti
         $o insert end " - muuttaa teksti ja luokituksia (jos huomautus on sinun tekemsi),\n" "teksti lista"
         $o insert end " - katsella huomautuksen tietoja (jos huomautuksen tekij on joku muu) tai\n" "teksti lista"
         $o insert end " - muokata teksti ja vaihtaa ksittelyn tilan (jos olet dokumentin tekij)\n\n" "teksti lista"
         $o insert end "Huomautusmerkkien vrit vaihtelevat kyttjn aseman mukaan seuraavasti:\n\n" teksti
         $o insert end "Olet tarkastaja:\n\n" "teksti lihavoitu"
         $o insert end "  " teksti
         $o insert end " Punainen  " "teksti punainen"
         $o insert end " - sinun lism huomautus\n\n" "teksti lista"
         $o insert end "  " teksti
         $o insert end " Violetti  " "teksti violetti"
         $o insert end " - jonkun muun lism huomautus\n\n" "teksti lista"
         $o insert end "Olet dokumentin tekij:\n\n" "teksti lihavoitu"
         $o insert end "  " teksti
         $o insert end " Punainen  " "teksti punainen"
         $o insert end " - huomautus, jota et ole viel ksitellyt\n\n" "teksti lista"
         $o insert end "  " teksti
         $o insert end " Keltainen " "teksti keltainen"
         $o insert end " - huomautus, jonka olet huomioinut, mutta et ksitellyt\n\n" "teksti lista"
         $o insert end "  " teksti
         $o insert end "  Vihre   " "teksti vihre"
         $o insert end " - huomautus, jonka olet jo ksitellyt\n\n" "teksti lista"
         $o insert end "Dokumentin tekijn voit ksitell eri tarkastajien tekemi huomautuksia ja " teksti
         $o insert end "asettaa niiden tilan (voit tehd sen mys napsauttamalla huomautusmerkki hiiren " teksti
         $o insert end "oikeanpuoleisella painikkeella ja valitsemalla haluamasi vaihtoehdon esiin " teksti
         $o insert end "tulevasta valikosta).\n\n" teksti
         $o insert end "Lopuksi voit sulkea ikkunan ja mahdollisesti hylt tai hyvksy muutokset." teksti
      }
      poista {
         $o insert end "Huomautuksen poistaminen\n\n" "teksti otsikko"
         $o insert end "Kuten muokkaaminen, mys poistaminen onnistuu vain itse tekemiesi huomautusten " teksti
         $o insert end "osalta. Napsauta merkki hiiren oikeanpuoleisella painikkeella ja valitse komento " teksti
         $o insert end "Poista" "teksti lihavoitu"
         $o insert end " (komentoa ei ny, jos huomautus ei ole tekemsi). sfia kysyy varmistuksen " teksti
         $o insert end "ja poistaa merkin, jos annat siihen luvan." teksti
      }
      tallenna {
         $o insert end "Huomautusten tallentaminen\n\n" "teksti otsikko"
         $o insert end "Valitse komento " teksti
         $o insert end "Tiedosto/Tallenna" "teksti lihavoitu"
         $o insert end ". sfia tallentaa kaikki huomautustiedot tiedostoon, jonka nimi muodostuu " teksti
         $o insert end "kyttjtunnuksestasi ja dokumentin nimest. Jos huomautustiedosto oli jo " teksti
         $o insert end "olemassa (ja sen tiedot oli luettu dokumentin " teksti
         $o insert end "avauksen" "teksti linkki$i avaa"; incr i
         $o insert end " yhteydess), ohjelma kirjoittaa uudet tiedot entisten plle. Jos " teksti
         $o insert end "tiedostoa ei ollut, ohjelma luo sen." teksti
      }
      raportti {
         $o insert end "Raportointi\n\n" "teksti otsikko"
         $o insert end "sfia:lla voit luoda kahdenlaisia raportteja: raportti kaikista huomautuksista " teksti
         $o insert end "tai yhteenvedosta.\n\n" teksti
         $o insert end "Komento " teksti
         $o insert end "Kaikki huomautukset " "teksti lihavoitu"
         $o insert end "tuo nkyviin ikkunan, jossa on listattu alekkain kaikki dokumentista lytyvt " teksti
         $o insert end "huomautukset. sfia kirjaa raporttiin jokaisesta huomautuksesta seuraavat tiedot:\n\n" teksti
         $o insert end " - tarkastajan tunnus\n" "teksti lista"
         $o insert end " - tekopivmr\n" "teksti lista"
         $o insert end " - sivun numero, jolla huomautus sijaitsee\n" "teksti lista"
         $o insert end " - huomautusteksti\n" "teksti lista"
         $o insert end " - kaikkien luokitusten arvot\n" "teksti lista"
         $o insert end " - ksittelyn tila\n\n" "teksti lista"
         $o insert end "Komento " teksti
         $o insert end "Yhteenveto" "teksti lihavoitu"
         $o insert end " nytt ikkunan, jossa kaikkien dokumentin huomautuksien mrt on laskettu " teksti
         $o insert end "yhteen luokitusten ja ksittelyn tilan mukaan. Jos dokumentin tekij ei ole " teksti
         $o insert end "mritellyt luokituksia, raportti nytt vain huomautusten ksittelyn tilat.\n\n" teksti
         $o insert end "Molemmissa raportti-ikkunoissa on painikkeet raportin tallentamiseksi sek " teksti
         $o insert end "tulostamiseksi. Tallennuspainikkeen napsautus avaa Tallenna-valintaikkunan, " teksti
         $o insert end "jossa voit valita raportin tallennuspaikan sek tiedostonimen. Ohjelma " teksti
         $o insert end "tallentaa raportin ASCII-muotoisena tekstitiedostona.\n\n" teksti
         $o insert end "Tulosta-komentoon liittyy painikkeen vieress oleva tekstikentt, johon " teksti
         $o insert end "voit kirjoittaa tulostuskomennon. Oletuksena on " teksti
         $o insert end "lpr" "teksti lihavoitu"
         $o insert end ", mutta voit muuttaa tilalle periaatteessa mink tahansa Unix/Linux-" teksti
         $o insert end "jrjestelmn komennon.\n\n" teksti
         $o insert end "Tulostaminen ei toimi Windows- ja Macintosh-ympristiss." teksti
      }
      lopeta {
         $o insert end "Ohjelman lopettaminen\n\n" "teksti otsikko"
         $o insert end "Valitse komento " teksti
         $o insert end "Tiedosto/Lopeta" "teksti lihavoitu"
         $o insert end ". Jos tietoja on muutettu, sfia kysyy luvan niiden tallentamiseen." teksti
      }
      esimerkki {
         $o insert end "Esimerkki ohjelman kytst:\nkytttapaus eri tilanteissa ja eri kyttjill\n\n" "teksti otsikko"
         $o insert end "Dokumentin tekij muuntaa haluamillaan vlineill asiakirjan sivut gif-" teksti
         $o insert end "muotoisiksi kuviksi ja kirjoittaa ddf-tiedoston, johon hn mrittelee " teksti
         $o insert end "dokumentin tietosislln sek luokitukset erilaisille huomautuksille. " teksti
         $o insert end "Tekij lhett kuvatiedostot sek ddf-tiedoston yhdelle tai useammalle " teksti
         $o insert end "tarkastajalle.\n\n" teksti
         $o insert end "Kukin tarkastaja ky lpi dokumentin ja lis huomautuksia tarpeellisiksi " teksti
         $o insert end "katsomiinsa kohtiin. Samalla hn merkitsee huomautusten lajin valitsemalla " teksti
         $o insert end "sopivat luokitusten arvot. Lopuksi hn tallentaa huomautukset ja lhett " teksti
         $o insert end "tallennuksen yhteydess syntyneen huomautustiedoston takaisin dokumentin " teksti
         $o insert end "tekijlle.\n\n" teksti
         $o insert end "Dokumentin tekij kokoaa kaikki huomautustiedostot yhdeksi tiedostoksi " teksti
         $o insert end "siten, ett se avautuu dokumentin mukana. Hn ky lpi huomautukset ja " teksti
         $o insert end "muuttaa niiden tilan sen mukaan, onko ksitellyt vai huomioinut huomautuksen " teksti
         $o insert end "ja lis tarvittaessa huomautusteksteihin omia kommenttejaan. Tekemll " teksti
         $o insert end "raportteja tekij voi helposti nhd huomautusten tilat ja mrt. Lopuksi " teksti
         $o insert end "tekij tallentaa huomautukset ja ottaa tarvittavat tiedostot mukaan " teksti
         $o insert end "tarkastustilaisuuteen.\n\n" teksti
         $o insert end "Tarkastustilaisuudessa tekij ja tarkastajat kyvt lpi dokumenttia. " teksti
         $o insert end "Kirjuri avaa dokumentin ja poistaa rajoitukset, jonka jlkeen hn pystyy " teksti
         $o insert end "muokkaamaan ja poistamaan huomautuksia sit mukaa kuin tarkastuksessa " teksti
         $o insert end "ptetn sek asettamaan samalla niiden tilan. Kirjuri tekee mys halutun " teksti
         $o insert end "mrn raportteja huomautuksista ja niiden yhteenvetotiedoista. Lopuksi " teksti
         $o insert end "ksitellyt huomautukset tallennetaan ja annetaan tekijlle.\n\n" teksti
         $o insert end "Tekij avaa dokumentin, poistaa rajoitukset ja merkitsee kaikki " teksti
         $o insert end "huomautukset ksittelemttmiksi. Tmn jlkeen hn ky huomautukset lpi ja " teksti
         $o insert end "tekee muutokset alkuperiseen asiakirjaansa." teksti
      }
   }

   $o tag configure teksti    -lmargin1 3 -lmargin2 3 -font {Helvetica 10}
   $o tag configure otsikko   -font {Helvetica 12 bold}
   $o tag configure lihavoitu -font {Helvetica 10 bold}
   $o tag configure lista     -lmargin1 10 -lmargin2 20 -spacing1 2 -spacing3 2
   $o tag configure harmaa    -background grey -font {Courier 10}
   $o tag configure keltainen -background yellow -font {Courier 10}
   $o tag configure punainen  -background red -font {Courier 10}
   $o tag configure vihre    -background green3 -font {Courier 10}
   $o tag configure violetti  -background magenta3 -font {Courier 10}
   $o tag bind sfia <Button-1> "naytaOhjeenTeksti sfia"
   $o tag bind avaa <Button-1> "naytaOhjeenTeksti avaa"
   $o tag bind navi <Button-1> "naytaOhjeenTeksti navi"
   $o tag bind lisaa <Button-1> "naytaOhjeenTeksti lisaa"
   $o tag bind muokkaa <Button-1> "naytaOhjeenTeksti muokkaa"
   $o tag bind poista <Button-1> "naytaOhjeenTeksti poista"
   $o tag bind raportti <Button-1> "naytaOhjeenTeksti raportti"
   $o tag bind tallenna <Button-1> "naytaOhjeenTeksti tallenna"
   $o tag bind lopeta <Button-1> "naytaOhjeenTeksti lopeta"

   for {set i 0} {$i <= 4} {incr i} {
      $o tag configure linkki$i    -foreground red -underline 1
      $o tag bind linkki$i <Enter> "$o tag configure linkki$i -foreground blue"
      $o tag bind linkki$i <Leave> "$o tag configure linkki$i -foreground red"
   }
   $o configure -state disabled
}

proc naytaTietoja {} {
   global k m

   tk_messageBox -icon info -type ok -title $k(tietoja) -parent . \
     -message "sfia v$m(sfia-versio)\n\n$k(idea): $m(sfia-idea)\n$k(toteutus): $m(sfia-toteutus)\n\n(c) 2001 $k(joy)\n$k(tkt)"
}

proc merkitseHuomautuksetKasittelemattomiksi {} {
   global d m

   foreach sivuID $d(sivulista) {
      if {[info exists d($sivuID-huom)]} {
         foreach huomID $d($sivuID-huom) {
            set d($huomID-tila) 2
         }
      }
   }
   incr m(muuttunut)
   paivitaSivu
}

proc luoKayttoliittyma {} {
   global k m

   frame            .menu            -relief flat -borderwidth 1
   pack             .menu            -fill x

   menubutton       .menu.tiedosto   -text "$k(tiedosto)" -underline 0 -menu .menu.tiedosto.t
   pack             .menu.tiedosto   -side left
   menu             .menu.tiedosto.t
   .menu.tiedosto.t add command      -label "$k(avaa)..." -underline 0 -command avaa
   .menu.tiedosto.t add command      -label "$k(tallenna)" -underline 0 -command tallenna
   .menu.tiedosto.t add command      -label "$k(sulje)" -underline 0 -command sulje
   .menu.tiedosto.t add separator
   .menu.tiedosto.t add cascade      -label "$k(luoraportti)..." -underline 1 -menu .menu.tiedosto.raportti
   .menu.tiedosto.t add separator
   .menu.tiedosto.t add command      -label "$k(lopeta)" -underline 0 -command lopeta
   menu .menu.tiedosto.raportti        -tearoff 0
   .menu.tiedosto.raportti add command -label "$k(kaikkihuomautukset)" -underline 0 -command {luoRaportti kaikki}
   .menu.tiedosto.raportti add command -label "$k(yhteenveto)" -underline 0 -command {luoRaportti yhteenveto}

   menubutton       .menu.muokkaa    -text "$k(muokkaa)" -underline 0 -menu .menu.muokkaa.m
   pack             .menu.muokkaa    -side left
   menu             .menu.muokkaa.m
   .menu.muokkaa.m add cascade -label "$k(kieli)..." -underline 0 -menu .menu.muokkaa.kieli
   menu .menu.muokkaa.kieli -tearoff 0
   for {set i 0} {$i < [llength $k(kielet)]} {incr i} {
      .menu.muokkaa.kieli add radiobutton -label [lindex $k(kielet) $i] -variable m(kieli) -value $i -command "vaihdaKieli $i"
   }
   .menu.muokkaa.m add cascade        -label "$k(merkinkoko)" -underline 0 -menu .menu.muokkaa.koko -state disabled
   menu .menu.muokkaa.koko -tearoff 0
   .menu.muokkaa.koko add radiobutton -label "$k(pienin)" -variable m(merkinkoko) -value 4 -command paivitaSivu
   .menu.muokkaa.koko add radiobutton -label "$k(pieni)" -variable m(merkinkoko) -value 6 -command paivitaSivu
   .menu.muokkaa.koko add radiobutton -label "$k(keskikoko)" -variable m(merkinkoko) -value 8 -command paivitaSivu
   .menu.muokkaa.koko add radiobutton -label "$k(suuri)" -variable m(merkinkoko) -value 10 -command paivitaSivu
   .menu.muokkaa.koko add radiobutton -label "$k(suurin)" -variable m(merkinkoko) -value 12 -command paivitaSivu
   .menu.muokkaa.m add separator
   .menu.muokkaa.m add checkbutton    -label "$k(rajoituksetkaytossa)" -underline 0 -variable m(rajoitukset) -command {
      if {!$m(rajoitukset)} {
         .menu.muokkaa.m entryconfigure 5 -state normal
      } else {
         .menu.muokkaa.m entryconfigure 5 -state disabled
      }
      paivitaSivu
   }
   .menu.muokkaa.m entryconfigure 4 -state normal
   .menu.muokkaa.m add command -label "$k(kaikkikasittelemattomiksi)" -underline 0 -command merkitseHuomautuksetKasittelemattomiksi
   .menu.muokkaa.m entryconfigure 5 -state disabled
   menubutton       .menu.nayta      -text "$k(nayta)" -underline 0 -menu .menu.nayta.n
   pack             .menu.nayta      -side left
   menu             .menu.nayta.n
   .menu.nayta.n    add command      -label "$k(valitsetarkastajat)..." -underline 0 -command valitseTarkastajat
   .menu.nayta.n    add command      -label "$k(huomautuslista)" -underline 0 -command {wm deiconify .hIkkuna}
   .menu.nayta.n    add command      -label "$k(arvotjaselitteet)" -underline 0 -command naytaArvotJaSelitteet

   menubutton       .menu.ohje       -text "$k(ohje)" -underline 0 -menu .menu.ohje.o
   pack             .menu.ohje       -side left
   menu             .menu.ohje.o
   .menu.ohje.o     add command      -label "$k(ohje)" -underline 0 -command avaaOhjeikkuna
   .menu.ohje.o     add command      -label "$k(tietoja)" -underline 0 -command naytaTietoja

   tk_menuBar .menu .menu.tiedosto .menu.muokkaa .menu.nayta .menu.ohje
   focus .menu

   frame  .navi          -relief flat
   pack   .navi          -side bottom

   button .navi.eka      -text "|<" -width 4 -command "siirry ensisivu"
   button .navi.ed       -text "<" -width 4 -command "siirry edelsivu"
   button .navi.seur     -text ">" -width 4 -command "siirry seursivu"
   button .navi.vika     -text ">|" -width 4 -command "siirry viimsivu"
   label  .navi.naytto   -relief sunken -width 10 -height 2
   label  .navi.tyhja    -relief flat -text "  "
   label  .navi.teksti   -relief flat -text "$k(siirry)"
   entry  .navi.siirry   -relief sunken -width 5

   pack   .navi.eka \
          .navi.ed \
          .navi.naytto \
          .navi.seur \
          .navi.vika \
          .navi.tyhja \
          .navi.teksti \
          .navi.siirry   -side left -pady 4

   frame     .tyotila          -relief sunken -borderwidth 1
   canvas    .tyotila.sivu     -borderwidth 0 \
                               -xscrollcommand {.tyotila.xpalkki set} -yscrollcommand {.tyotila.ypalkki set}
   scrollbar .tyotila.ypalkki  -orient vertical -command {.tyotila.sivu yview}
   scrollbar .tyotila.xpalkki  -orient horizontal -command {.tyotila.sivu xview}
   grid      .tyotila.sivu     -row 0 -column 0 -sticky nw
   grid      .tyotila.xpalkki  -row 1 -column 0 -sticky ew
   grid      .tyotila.ypalkki  -row 0 -column 1 -sticky ns
   grid      columnconfigure   .tyotila 0 -weight 1
   grid      rowconfigure      .tyotila 0 -weight 1
   pack      .tyotila          -expand yes -fill both

   menu .popup -tearoff 0

   bind .navi.siirry <KeyPress> {
      if {![regexp "\[0-9\b\r\]" "%A"]} {
         break
      } elseif {[regexp "\r" "%A"]} {
         if {[.navi.siirry get] < 1 || [.navi.siirry get] > $d(sivumaara)} {
            .navi.siirry selection range 0 end
         } else {
            siirry [expr [.navi.siirry get] - 1]
            .navi.siirry delete 0 end
            focus .menu
         }
      }
   }

   .tyotila.sivu bind merkki <Enter> {
      set huomID [lindex [.tyotila.sivu gettags current] 1]
      korostusKayttoon $huomID {ikkuna lista merkki}
   }

   .tyotila.sivu bind merkki <Leave> {
      set huomID [lindex [.tyotila.sivu gettags current] 1]
      korostusPois $huomID {ikkuna lista merkki}
   }

   .tyotila.sivu bind merkki <Button-1> {
      set huomID [lindex [.tyotila.sivu gettags current] 1]
      if {[.hIkkuna.teksti tag ranges $huomID] != ""} {
         vaihdaKohdistin watch
         .hIkkuna.teksti see [lindex [.hIkkuna.teksti tag ranges $huomID] 0]
         vaihdaKohdistin oletus
      }
   }

   .tyotila.sivu bind merkki <Button-3> {
      set huomID [lindex [.tyotila.sivu gettags current] 1]
      .popup delete 0 7
      .popup add command -label $k(muokkaa) -command "avaaMuokkausikkuna $huomID"
      .popup add command -label $k(poista) -command {
         if {[tk_messageBox -icon question -type yesno -title "$k(poista)" -parent . \
             -message $k(huomautuksenpoistaminen)] == "yes"} { 
            poistaHuomautusmerkki $huomID
         }
      }
      if {$m(rajoitukset)} {
         if {$m(kayttaja) != $d($huomID-tarkastaja)} {
            .popup entryconfigure 0 -label $k(nayta)
            .popup entryconfigure 1 -state disabled
         }
      }
      if {$m(kayttaja) == $m(tekija) || !$m(rajoitukset)} {
         .popup add separator
         .popup add radiobutton -label $k(kasitelty) -foreground green3 -variable d($huomID-tila) \
                                -value 0 -command "vaihdaHuomautuksenTila $huomID 0"
         .popup add radiobutton -label $k(huomioitu) -foreground yellow -variable d($huomID-tila) \
                                -value 1 -command "vaihdaHuomautuksenTila $huomID 1"
         .popup add radiobutton -label $k(kasittelematta) -foreground red1 -variable d($huomID-tila) \
                                -value 2 -command "vaihdaHuomautuksenTila $huomID 2"
      }
      catch [tk_popup .popup %X %Y]
   }
}

wm protocol . WM_DELETE_WINDOW lopeta

asetaTekstit
asetaAlkuasetukset
lataaKielitiedot $m(kieli)
luoKayttoliittyma
vaihdaValikonTila disabled
vaihdaPainikkeidenTila disabled
asetaIkkunanOtsikko
avaaHuomautusikkuna

